//----------------------------------------------------------------------------
/// \file
/// Enumerations for TBarCode.
/// Contains all enumerations used in API-calls of TBarCode. 
/// \author TEC-IT Datenverarbeitung GmbH
/// \author Wagnerstr. 6, A-4400 Steyr, AUSTRIA/EUROPE
/// \author http://www.tec-it.com
/// \author Copyright&copy; by TEC-IT Datenverarbeitung GmbH
/// \date    1996-2006
/// \version 7.0
/// \note This product is supported. Please send an email to support@tec-it.com
//----------------------------------------------------------------------------

// ----------
// ATTENTION: Special treatment, when building TBarCode ActiveX (instead of TBarCode DLL)
// The type library of the TBarCode ActiveX contains this file.
// The MIDL tools automatically creates a header file 'TBarCode.h'. __TBarCode_h__ indicates
// that this file is used. If 'TBarCode.h' is used, then do not include this file.
#ifndef __TBarCode_h__    
// ----------


#ifndef __TECBCEnum_H
#define __TECBCEnum_H

//----------------------------------------------------------------------------
/// Help-String Macro (for ActiveX interface).
/// Expands to ["My String"] if compiling an .ODL file
/// \internal
//----------------------------------------------------------------------------
#ifdef TECIT_HELPSTRINGS
#  define   TECIT_HS(s) [helpstring(s)]
#else
#  undef    TECIT_HS
#  define   TECIT_HS(s)
#endif

/*//----------------------------------------------------------------------------
//
//  Standard print ratios
//
//  1B, 2B, 3B, 4B    .....   bar widths 
//  1S, 2S, 3S, 4S    .....   space widths 
//
//----------------------------------------------------------------------------*/
/* eBC_None,                Print ratios                                                    standard check digit                                */
                                                                                                            
/* eBC_Code11,              1:2.24:3.48:1:2.24          (1B:2B:3B:1S:2S)                    eCDNone                                             */
/* eBC_2OF5,                1:3:4.5:1:3                 (1B:2B:3B:1S:2S)                    eCDNone                                             */
/* eBC_2OF5IL,              1:3:1:3                     (1B:2B:1S:2S)                       eCDNone                                             */
/* eBC_2OF5IATA,            1:3:1                       (1B:2B:1S)                          eCDNone                                             */
/* eBC_2OF5M,               1:3:4.5:1:3                 (1B:2B:3B:1S:2S)                    eCDNone                                             */
/* eBC_2OF5DL,              1:3:1:3                     (1B:2B:1S:2S)                       eCDNone                                             */
/* eBC_2OF5IND,             1:3:1                       (1B:2B:1S)                          eCDNone                                             */
/* eBC_3OF9,                1:3:1:3                     (1B:2B:1S:2S)                       eCDNone                                             */
/* eBC_3OF9A,               1:3:1:3                     (1B:2B:1S:2S)                       eCDNone                                             */
/* eBC_EAN8,                1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDEAN8                                             */
/* eBC_EAN8P2,              1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDEAN8                                             */
/* eBC_EAN8P5,              1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDEAN8                                             */
/* eBC_EAN13,               1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDEAN13                                            */
/* eBC_EAN13P2,             1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDEAN13                                            */
/* eBC_EAN13P5,             1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDEAN13                                            */
/* eBC_EAN128,              1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDCode128                                          */
/* eBC_UPC12,               1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDUPCA                                             */
/* eBC_CodaBar2,            1:3:1:3                     (1B:2B:1S:2S)                       eCDNone                                             */
/* eBC_CodaBar18,           -------                                                         ----                                                */
/* eBC_Code128,             1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDCode128                                          */
/* eBC_Code128A,            1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDCode128                                          */
/* eBC_Code128B,            1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDCode128                                          */
/* eBC_Code128C,            1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDCode128                                          */
/* eBC_DPLeit,              1:3:1:3                     (1B:2B:1S:2S)                       eCDDPLeit                                           */
/* eBC_DPIdent,             1:3:1:3                     (1B:2B:1S:2S)                       eCDDPIdent                                          */
/* eBC_Code16K,             -------                                                         ----                                                */
/* eBC_49,                  -------                                                         ----                                                */
/* eBC_9OF3,                1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCD2Mod47                                           */
/* eBC_UPC25,               -------                                                         ----                                                */
/* eBC_UPCD1,               -------                                                         ----                                                */
/* eBC_Flattermarken,       1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_RSS14,               1:2:3:4:5:6:7:8:9:          (1B:2B:3B:4B:5B:6B:7B:8B:9B:        eCDNone                                             */
/*                          1:2:3:4:5:6:7:8:9            1S:2S:3S:4S:5S:6S:7S:8S:9S)                                                            */
/* eBC_RSSLtd,              1:2:3:4:5:6:7:8:9:          (1B:2B:3B:4B:5B:6B:7B:8B:9B:        eCDNone                                             */
/*                          1:2:3:4:5:6:7:8:9            1S:2S:3S:4S:5S:6S:7S:8S:9S)                                                            */
/* eBC_RSSExp,              -------                                                         ----                                                */
/* eBC_TelepenAlpha,        1:3:1:3                     (1B:2B:1S:2S)                       eCDNone                                             */
/* eBC_UCC128,              1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDCode128                                          */
/* eBC_UPCA,                1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDUPCA                                             */
/* eBC_UPCAP2,              1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDUPCA                                             */
/* eBC_UPCAP5,              1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDUPCA                                             */
/* eBC_UPCE,                1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDUPCE                                             */
/* eBC_UPCEP2,              1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDUPCE                                             */
/* eBC_UPCEP5,              1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDUPCE                                             */
/* eBC_USPSPostNet5,            1:1                         (1B:1S)                             eCDUSPSPostnet                                          */
/* eBC_USPSPostNet6,            1:1                         (1B:1S)                             eCDUSPSPostnet                                          */
/* eBC_USPSPostNet8,            1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_USPSPostNet10,           1:1                         (1B:1S)                             eCDUSPSPostnet                                          */
/* eBC_USPSPostNet11,           1:1                         (1B:1S)                             eCDUSPSPostnet                                          */
/* eBC_USPSPostNet12,           1:1                         (1B:1S)                             eCDUSPSPostnet                                          */
/* eBC_Plessey,             1:2:1:2                     (1B:2B:1S:2S)                       eCDPlessey                                          */
/* eBC_MSI,                 1:2:1:2                     (1B:2B:1S:2S)                       eCDMSI1                                             */
/* eBC_SSCC18,              1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDMod10                                            */
/* eBC_FIM,                 -------                                                         ----                                                */
/* eBC_LOGMARS,             1:3:1:3                     (1B:2B:1S:2S)                       eCDNone                                             */
/* eBC_Pharma1,             1:3:2:4:2:3                 (1B:2B:1C:2C:1S:2S)                 eCDNone                                             */
/* eBC_PZN,                 1:2.5:1:2.5                 (1B:2B:1S:2S)                       eCDPZN                                              */
/* eBC_Pharma2,             1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_GP,                  -------                                                         ----                                                */
/* eBC_PDF417,              1:2:3:4:5:6:7:8:            (1B:2B:3B:4B:5B:6B:7B:8B:                                                               
                            1:2:3:4:5:6                 1S:2S:3S:4S:5S:6S)                  eCDNone                                             */
/* eBC_PDF417Trunc,         1:2:3:4:5:6:7:8:            (1B:2B:3B:4B:5B:6B:7B:8B:                                                               
                            1:2:3:4:5:6                 1S:2S:3S:4S:5S:6S)                  eCDNone                                             */
/* eBC_MAXICODE,            -------                                                         ----                                                */
/* eBC_QRCode,              1:1                         (1B:1S)                             ----                                                */
/* eBC_Code128A,            1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDCode128                                          */
/* eBC_Code128B,            1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDCode128                                          */
/* eBC_Code128C,            1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDCode128                                          */
/* eBC_9OF3A,               1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCD2Mod47                                           */
/* eBC_AusPostCustom,       1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_AusPostCustom2,      1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_AusPostCustom3,      1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_AusPostReplyPaid,    1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_AusPostRouting,      1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_AusPostRedirect,     1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_ISBN,                1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDEAN13                                            */
/* eBC_RM4SCC,              1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_DataMatrix,          -------                                                         ----                                                */
/* eBC_EAN14,               -------                                                         eCDEAN14                                            */
/* eBC_CODABLOCK_E,         1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           ----                                                */
/* eBC_CODABLOCK_F,         1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           ----                                                */
/* eBC_NVE18,               1:2:3:4:1:2:3:4             (1B:2B:3B:4B:1S:2S:3S:4S)           eCDMod10                                            */
/* eBC_JapanesePostal       1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_KoreanPostalAuth     1:3:4                       (1B:1S:2S)                          eCDMod10Kor                                         */
/* eBC_RSS14Trunc,          1:2:3:4:5:6:7:8:9:          (1B:2B:3B:4B:5B:6B:7B:8B:9B:        eCDNone                                             */
/*                          1:2:3:4:5:6:7:8:9            1S:2S:3S:4S:5S:6S:7S:8S:9S)                                                            */
/* eBC_RSS14Stacked,        1:2:3:4:5:6:7:8:9:          (1B:2B:3B:4B:5B:6B:7B:8B:9B:        eCDNone                                             */
/*                          1:2:3:4:5:6:7:8:9            1S:2S:3S:4S:5S:6S:7S:8S:9S)                                                            */
/* eBC_RSS14StackedOmni,    1:2:3:4:5:6:7:8:9:          (1B:2B:3B:4B:5B:6B:7B:8B:9B:        eCDNone                                             */
/*                          1:2:3:4:5:6:7:8:9            1S:2S:3S:4S:5S:6S:7S:8S:9S)                                                            */
/* eBC_RSSExpStacked,       1:2:3:4:5:6:7:8:9:          (1B:2B:3B:4B:5B:6B:7B:8B:9B:        eCDNone                                             */
/*                          1:2:3:4:5:6:7:8:9            1S:2S:3S:4S:5S:6S:7S:8S:9S)                                                            */
/* eBC_Planet12,            1:1                         (1B:1S)                             eCDMod10Pla                                         */
/* eBC_Planet14,            1:1                         (1B:1S)                             eCDMod10Pla                                         */
/* eBC_MicroPDF417,         1:2:3:4:5:6                 (1B:2B:3B:4B:5B:6B:                                                               
                            1:2:3:4:5:6                 1S:2S:3S:4S:5S:6S)                  eCDNone                                             */
/* eBC_USPSOneCode4CB,      1:1                         (1B:1S)                             eCDNone                                             */
/* eBC_PlesseyBidir,        1:2:3:1:2                   (1B:2B:3T:1S:2S)                    eCDPlessey                                          */


//----------------------------------------------------------------------------
///  Supported Barcodes.
///  Enumerations for all supported barcode symbologies 
//----------------------------------------------------------------------------
typedef enum /*tag_BarCType*/
{
  TECIT_HS("None")                            eBC_None        = 0,        ///< <b> No barcode type </b> \n Enumeration Value: 0
                                                                          ///< \n Nothing is drawn - use it when the bar code should be disabled.
                                                                          ///< \n
  TECIT_HS("Code 11")                         eBC_Code11      = 1,        ///< <b> Code 11 </b> \n Enumeration Value: 1 \n
                                                                          ///< - Codeable characters: ["0" - "9", "-"]
                                                                          ///< - Default check-digit method: None 
                                                                          ///< - Recommended check digit methods: #eCD1Code11 (one check-digits) or #eCD2Code11 (two check-digits)
                                                                          ///< \n\n
  TECIT_HS("Code 2OF5 Standard")              eBC_2OF5        = 2,        ///< <b> Code 2 of 5 </b>\n Enumeration Value: 2
                                                                          ///< \n The standard version - non interleaved; alias for Code 2 of 5 Matrix.
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: None 
                                                                          ///< - Recommended check digit methods: #eCDMod10
                                                                          ///< \n\n
  TECIT_HS("Code 2OF5 Interleaved")           eBC_2OF5IL      = 3,        ///< <b> Interleaved 2 of 5 </b>\n Enumeration Value: 3
                                                                          ///< \n Interleaved version - encodes only an even number of digits, uses a leading "0" automatically (see BCSetAutoCorrect()).
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: None 
                                                                          ///< - Recommended check digit methods: #eCDMod10
                                                                          ///< \n\n
  TECIT_HS("Code 2OF5 IATA")                  eBC_2OF5IATA    = 4,        ///< <b> Code 2 of 5 IATA </b>\n Enumeration Value: 4
                                                                          ///< \n The IATA version - non interleaved.
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: None 
                                                                          ///< - Recommended check digit methods: #eCDMod10
                                                                          ///< \n\n
  TECIT_HS("Code 2OF5 Matrix")                eBC_2OF5M       = 5,        ///< <b> Code 2 of 5 Matrix </b> \n Enumeration Value: 5
                                                                          ///< \n Alias for Code 2 of 5 standard.
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: None 
                                                                          ///< - Recommended check digit methods: #eCDMod10
                                                                          ///< \n\n
  TECIT_HS("Code 2OF5 DataLogic")             eBC_2OF5DL      = 6,        ///< <b> Code 2 of 5 Data Logic </b> \n Enumeration Value: 6  
                                                                          ///< \n Data Logic version of Code 2 of 5; not interleaved.
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: None 
                                                                          ///< - Recommended check digit methods: #eCDMod10
                                                                          ///< \n\n 
  TECIT_HS("Code 2OF5 Industry")              eBC_2OF5IND     = 7,        ///< <b> Code 2 of 5 Industrial </b> \n Enumeration Value: 7
                                                                          ///< \n Industrial version of Code 2 of 5; not interleaved.
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: None 
                                                                          ///< - Recommended check digit methods: #eCDMod10
                                                                          ///< \n\n
  TECIT_HS("Code 39")                         eBC_3OF9        = 8,        ///< <b> Code 3 of 9 (Code 39) </b> \n Enumeration Value: 8
                                                                          ///< \n In common use, start- and stop characters "*" (asterisk) are created automatically by TBarCode and must not be included in the input data
                                                                          ///< (start/stop characters are not displayed in the human readable text).
                                                                          ///< - Codeable characters: ["0"-"9", "A"-"Z", "-", ".", " ", "*", "$", "/", "+", "%"]
                                                                          ///< - Default check-digit method: None 
                                                                          ///< - Recommended check digit methods: #eCDMod43
                                                                          ///< \n\n
  TECIT_HS("Code 39 Full ASCII")              eBC_3OF9A       = 9,        ///< <b> Code 3 of 9 (Code 39) ASCII </b> \n Enumeration Value: 9
                                                                          ///< \n In common use, start- and stop characters "*" (asterisk) are created automatically by TBarCode and must not be included in the input data; they are not displayed in the human readable text.
                                                                          ///< - Codeable characters: All ASCII-characters from 0x00 to 0x7f (0 - 127)
                                                                          ///< - Default check-digit method: None
                                                                          ///< - Recommended check digit methods: #eCDMod43
                                                                          ///< \n\n 
  TECIT_HS("EAN8")                            eBC_EAN8        = 10,       ///< <b> EAN-8 </b> \n Enumeration Value: 10
                                                                          ///< \n In common use for retail applications and article numbering (EAN: European Article Numbering system), the check-digit is calculated automatically if not specified in the input data (that is when only 7 digits are used for creating the code).
                                                                          ///< - Encodes 7 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDEAN8 
                                                                          ///< - Recommended check digit methods: #eCDEAN8 (None for special applications)
                                                                          ///< 
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n 
  TECIT_HS("EAN8P2")                          eBC_EAN8P2      = 11,       ///< <b> EAN-8 with 2 digits add on </b> \n Enumeration Value: 11
                                                                          ///< \n In common use for retail applications and article numbering (EAN: European Article Numbering system), the check-digit is calculated automatically if not specified in the input data (that is when only 9 digits are used for creating the code).
                                                                          ///< - Encodes 7+2 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDEAN8 
                                                                          ///< - Recommended check digit methods: #eCDEAN8 (None for special applications)
                                                                          ///< \n\n
  TECIT_HS("EAN8P5")                          eBC_EAN8P5      = 12,       ///< <b> EAN-8 with 5 digits add on </b>\n Enumeration Value: 12
                                                                          ///< \n In common use for retail applications and article numbering (EAN: European Article Numbering system), the check-digit is calculated automatically if not specified in the input data (that is when only 11 digits are used for creating the code).
                                                                          ///< - Encodes 7+5 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDEAN8 
                                                                          ///< - Recommended check digit methods: #eCDEAN8 (None for special applications)
                                                                          ///< \n\n
  TECIT_HS("EAN13")                           eBC_EAN13       = 13,       ///< <b> EAN-13 </b> \n Enumeration Value: 13
                                                                          ///< \n In common use for retail applications and article numbering (EAN: European Article Numbering system), the check-digit is calculated automatically if not specified in the input data (that is when only 12 digits are used for creating the code). 
                                                                          ///< - Encodes 12 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDEAN13 
                                                                          ///< - Recommended check digit methods: #eCDEAN13 (None for special applications)
                                                                          ///<
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n
  TECIT_HS("EAN13P2")                         eBC_EAN13P2     = 14,       ///< <b> EAN-13 - with 2 digits add on </b> \n Enumeration Value: 14
                                                                          ///< \n In common use for retail applications and article numbering (EAN: European Article Numbering system), the check-digit is calculated automatically if not specified in the input data (that is when only 14 digits are used for creating the code).
                                                                          ///< - Encodes 12+2 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDEAN13 
                                                                          ///< - Recommended check digit methods: #eCDEAN13 (None for special applications)
                                                                          ///< \n\n
  TECIT_HS("EAN13P5")                         eBC_EAN13P5     = 15,       ///< <b> EAN-13 - with 5 digits add on </b> \n Enumeration Value: 15
                                                                          ///< \n In common use for retail applications and article numbering (EAN: European Article Numbering system), the check-digit is calculated automatically if not specified in the input data (that is when only 17 digits are used for creating the code). 
                                                                          ///< - Encodes 12+5 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDEAN13 
                                                                          ///< - Recommended check digit methods: #eCDEAN13 (None for special applications)
                                                                          ///< \n\n
  TECIT_HS("UCC/EAN-128")                     eBC_EAN128      = 16,       ///< <b> EAN-128 </b> \n Enumeration Value: 16
                                                                          ///< \n EAN-128 is based upon the Code128, but with the FNC1 function character encoded at the 2nd position (after the start code); this allows scanners and data processing software to differentiate EAN-128 from other symbologies.
                                                                          ///< - The FNC1 at 2nd position is inserted automatically by TBarCode
                                                                          ///< - The symbology internal checksum (Mod 103) is calculated automatically
                                                                          ///< - Within the EAN UCC System you can use Application Identifiers to prefix encoded data
                                                                          ///< - Codeable characters: All ASCII-characters from 0x00 to 0x7f (0 - 127)
                                                                          ///< - Default check-sum method: #eCDEAN128 (symbology internal checksum method)
                                                                          ///< - Recommended checksum calculation: #eCDEAN128, in addition #eCDMod10 or #eCDMod43 for special applications
                                                                          ///<
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n
  TECIT_HS("UPC12")                           eBC_UPC12       = 17,       ///< <b> UPC-12 Digits </b> \n Enumeration Value: 17
                                                                          ///< \n In common use for retail applications and article numbering (UPC: Universal Product Code), the check-digit is calculated automatically if not specified in the input data (that is when only 11 digits are used for creating the code) 
                                                                          ///< \n Check digit is calculated automatically if not specified in the input data (that is when only 11 digits are used for creating the code)
                                                                          ///< \n UPC-A and UPC-12 are identical.
                                                                          ///< - Encodes 11 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUPCA
                                                                          ///< - Recommended check digit methods: #eCDUPCA, #eCDNone for special applications
                                                                          ///< \n\n
  TECIT_HS("CodaBar 2 Widths")                eBC_CodaBar2    = 18,       ///< <b> CodaBar (2 widths) </b> \n Enumeration Value: 18
                                                                          ///< \n Codabar using 2 different bar/space widths 
                                                                          ///< \n "A", "B", "C" or "D" are used as start/sop characters only.
                                                                          ///< - Codeable characters: ["0" - "9", "-", "$", ":", "/", ".", "+", "A", "B", "C", "D"]
                                                                          ///< - Default check-digit method: None
                                                                          ///< - Recommended check digit methods: None
                                                                          ///< \n\n
  TECIT_HS("CodaBar 18 Widths")               eBC_CodaBar18   = 19,       ///< <b> CodaBar (18 widths)</b> \n Enumeration Value: 19
                                                                          ///< \n NOT SUPPORTED BY THE CURRENT VERSION.
                                                                          ///< \n
  TECIT_HS("Code128")                         eBC_Code128     = 20,       ///< <b> Code 128 </b> \n Enumeration Value: 20
                                                                          ///< \n In common use, beside this auto switching Code128 it is available in 3 different subsets (Code128A, Code128B, Code128C) 
                                                                          ///< \n Input data is analyzed and the best suited subset(s) will be used
                                                                          ///< \n Subset switching is also done automatically when necessary; the smallest possible symbol will be generated.
                                                                          ///< - The symbology internal check-digit (Mod 103) is calculated automatically
                                                                          ///< - Codeable characters: All ASCII-characters from 0x00 to 0x7f (0 - 127)
                                                                          ///< - Default check-sum method: #eCDCode128 (symbology internal checksum method)
                                                                          ///< - Recommended check digit methods: #eCDCode128, in addition #eCDMod10 or #eCDMod43 for special applications
                                                                          ///< \n\n
  TECIT_HS("DP Leitcode")                     eBC_DPLeit      = 21,       ///< <b> Deutsche Post Leitcode </b> \n Enumeration Value: 21
                                                                          ///< \n Used by Deutsche Post (is a variant of 2 of 5 interleaved), human readable text formatted accoring to specification.
                                                                          ///< - Encodes 13 digits and 1 symbology internal check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDDPLeit
                                                                          ///< - Recommended check digit methods: #eCDDPLeit
                                                                          ///< \n\n
  TECIT_HS("DP Identcode")                    eBC_DPIdent     = 22,       ///< <b> Deutsche Post Identcode </b> \n Enumeration Value: 22
                                                                          ///< \n Used by Deutsche Post  (is a variant of 2 of 5 interleaved), human readable text formatted accoring to specification.
                                                                          ///< - Encodes 11 digits and 1 symbology internal check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDDPIdent
                                                                          ///< - Recommended check digit methods: #eCDDPIdent
                                                                          ///< \n\n
  TECIT_HS("Code 16K")                        eBC_Code16K     = 23,       ///< <b> Code 16 K </b> \n Enumeration Value: 23
                                                                          ///< \n NOT SUPPORTED BY THE CURRENT VERSION.
                                                                          ///< \n
  TECIT_HS("Code 49")                         eBC_49          = 24,       ///< <b> Code 49 </b> \n Enumeration Value: 24
                                                                          ///< \n NOT SUPPORTED BY THE CURRENT VERSION.
                                                                          ///< \n
  TECIT_HS("Code 93")                         eBC_9OF3        = 25,       ///< <b> Code 93 </b> \n Enumeration Value: 25
                                                                          ///< \n In common use, offers higher data density than Code 39 (with same symbology character set).
                                                                          ///< - Codeable characters: ["0"-"9", "A"-"Z", "-", ".", Space, "$", "/", "+", "%"]
                                                                          ///< - Default check-sum calculation: #eCD2Mod47 (uses 2 checksum characters)
                                                                          ///< - Recommended checksum calculation: #eCD2Mod47
                                                                          ///< \n\n
  TECIT_HS("UPC25")                           eBC_UPC25       = 26,       ///< <b> UPC25 </b> \n Enumeration Value: 26
                                                                          ///< \n NOT SUPPORTED BY THE CURRENT VERSION.
                                                                          ///< \n
  TECIT_HS("UPCD1")                           eBC_UPCD1       = 27,       ///< <b> UPCD1 </b> \n Enumeration Value: 27
                                                                          ///< \n NOT SUPPORTED BY THE CURRENT VERSION.
                                                                          ///< \n
  TECIT_HS("Flattermarken")                   eBC_Flattermarken = 28,     ///< <b> Flattermarken </b> \n Enumeration Value: 28
                                                                          ///< - Codeable characters: ["0"-"9"]
                                                                          ///< - Default check-digit method: None
                                                                          ///< - Recommended check digit methods: None
                                                                          ///< \n\n
  TECIT_HS("RSS-14")                          eBC_RSS14       = 29,       ///< <b> RSS-14 (Reduced Space Symbology) </b> \n Enumeration Value: 29
                                                                          ///< \n Used to encode the GTIN (Global Trade Item Number) with Application identifier (AI) 01; 
                                                                          ///<   The GTIN consists of a packaging indicator (0-9) followed by a 12 digit number (taken from the EAN-13 article number system) followed by a check digit;
                                                                          ///<   The height of the symbol should be at least 33X to support omni-directional scanning (X = module width), no quiet zone is needed.
                                                                          ///< - Codeable characters: ["0"-"9"], the AI 01 is automatically encoded by TBarCode (must not be included in the input data!)
                                                                          ///< - The check digit is calculated automatically
                                                                          ///< - Default check-digit method: Check digit is part of the code
                                                                          ///< - Recommended check digit methods: None (is already part of the symbology)
                                                                          ///<
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n
  TECIT_HS("RSS Limited")                     eBC_RSSLtd      = 30,       ///< <b> RSS Limited </b> \n Enumeration Value: 30
                                                                          ///< \n Similar to RSS-14 but smaller in size and limited to packaging indicator 0 and 1 (first digit).
                                                                          ///< - No quiet zone is needed
                                                                          ///< - Encodes 13 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0"-"9"], 
                                                                          ///< - The check digit is calculated automatically
                                                                          ///< - Default check-digit method: None (Check digit is part of the code)
                                                                          ///< - Recommended check digit methods: None (is already part of the symbology)
                                                                          ///<
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n
  TECIT_HS("RSS Expanded")                    eBC_RSSExp      = 31,       ///< <b> RSS Expanded </b>\n Enumeration Value: 31
                                                                          ///< \n Reduced Space Symbology for encoding variable length of data with support for AI compaction; Omni-directional scanning is possible, also a stacked version is available (see #eBC_RSSExpStacked).
                                                                          ///< - No quiet zone is needed
                                                                          ///< - Encodes up to 74 numeric or 41 alphabetic characters
                                                                          ///< - Codeable characters: alphanumeric and special characters (ISO-646 table)
                                                                          ///< - The check digit is calculated automatically
                                                                          ///< - Default check-digit method: None (check digit is part of the code)
                                                                          ///< - Recommended check digit methods: None (check digit is part of the code)
                                                                          ///<
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n
  TECIT_HS("Telepen Alpha")                   eBC_TelepenAlpha = 32,      ///< <b> Telepen Alpha </b> \n Enumeration Value: 32
                                                                          ///< \n Telepen Alpha is the alphanumeric variant of Telepen; There is also a double density numeric only mode, which is not implemented yet.
                                                                          ///< - Codeable characters: ASCII characters between 0-127
                                                                          ///< - Default check-digit method: None (check digit is part of the code)
                                                                          ///< - Recommended check digit methods: None (Check digit is part of the code)
                                                                          ///< \n\n
  TECIT_HS("UCC128")                          eBC_UCC128      = 33,       ///< <b>UCC-128 </b> \n Enumeration Value: 33
                                                                          ///< \n Same as EAN-128 (refer to #eBC_EAN128).
                                                                          ///< \n\n
  TECIT_HS("UPCA")                            eBC_UPCA        = 34,       ///< <b> UPC A </b> \n Enumeration Value: 34
                                                                          ///< \n In common use for retail applications and article numbering (UPC: Universal Product Code); UPC-A and UPC-12 are identical;
                                                                          ///< \n The check digit is calculated automatically if not specified in the input data (that is when only 11 digits are used for creating the code).
                                                                          ///< - Encodes 11 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUPCA
                                                                          ///< - Recommended check digit methods: #eCDUPCA (None for special applications)
                                                                          ///<
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n
  TECIT_HS("UPCAP2")                          eBC_UPCAP2      = 35,       ///< <b> UPC A - with 2 digit add on </b> \n Enumeration Value: 35
                                                                          ///< \n In common use for retail applications and article numbering (UPC Universal Product Code); The check digit is calculated automatically if not specified in the input data (that is when only 13 digits are used for creating the code).
                                                                          ///<
                                                                          ///< - Encodes 11+2 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUPCA
                                                                          ///< - Recommended check digit methods: #eCDUPCA (None for special applications only)
                                                                          ///< \n\n 
  TECIT_HS("UPCAP5")                          eBC_UPCAP5      = 36,       ///< <b> UPC A - 5 digit add on </b> \n Enumeration Value: 36
                                                                          ///< \n In common use for retail applications and article numbering (UPC: Universal Product Code);
                                                                          ///< \n The check digit is calculated automatically if not specified in the input data (that is when only 16 digits are used for creating the code).
                                                                          ///< - Encodes 11+5 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUPCA
                                                                          ///< - Recommended check digit methods: #eCDUPCA (None for special applications only)
                                                                          ///< \n\n 
  TECIT_HS("UPCE")                            eBC_UPCE        = 37,       ///< <b> UPC E </b> \n Enumeration Value: 37
                                                                          ///< \n In common use for retail applications and article numbering (UPC: Universal Product Code);
                                                                          ///< \n The check digit is calculated automatically if not specified in the input data (that is when only 7 digits are used for creating the code).
                                                                          ///< - Encodes 7 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUPCE
                                                                          ///< - Recommended check digit methods: #eCDUPCE (None for special applications only)
                                                                          ///<
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n 
  TECIT_HS("UPCEP2")                          eBC_UPCEP2      = 38,       ///< <b> UPC E - with 2 digit add on </b> \n Enumeration Value: 38
                                                                          ///< \n In common use for retail applications and article numbering (UPC: Universal Product Code)
                                                                          ///< \n Check digit is calculated automatically if not specified in the input data (that is when only 9 digits are used for creating the code).
                                                                          ///< - Encodes 7+2 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUPCE
                                                                          ///< - Recommended check digit methods: #eCDUPCE (None for special applications only)
                                                                          ///< \n\n 
  TECIT_HS("UPCEP5")                          eBC_UPCEP5      = 39,       ///< <b> UPC E - with 5 digit add on </b> \n Enumeration Value: 39
                                                                          ///< \n In common use for retail applications and article numbering (UPC: Universal Product Code)
                                                                          ///< \n Check digit is calculated automatically if not specified in the input data (that is when only 12 digits are used for creating the code).
                                                                          ///< - Encodes 7+5 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUPCE
                                                                          ///< - Recommended check digit methods: #eCDUPCE (None for special applications)
                                                                          ///< \n\n 
  TECIT_HS("USPS PostNet5")                        eBC_USPSPostNet5    = 40,       ///< <b>USPS  PostNet ZIP (5 digits) </b> \n Enumeration Value: 40
                                                                          ///< \n USPS Postnet symbol for encoding the US ZIP Code (5 digits)
                                                                          ///< \n Check digit is always calculated automatically and cannot be specified in the input data.
                                                                          ///< - Encodes 5 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUSPSPostnet
                                                                          ///< - Recommended check digit methods: #eCDUSPSPostnet
                                                                          ///< \n\n
  TECIT_HS("USPS PostNet6")                        eBC_USPSPostNet6    = 41,       ///< <b>USPS  PostNet ZIP (5 digits + check digit) </b> \n Enumeration Value: 41
                                                                          ///< \n USPS Postnet symbol for encoding the US ZIP Code (5 digits)
                                                                          ///< \n The required check digit is calculated automatically if length of input data equals 5; the user can also supply the 6th digit (no validation is performed).
                                                                          ///< - Encodes 5 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUSPSPostnet (if 5 digits are specified for the input data), #eCDNone (if 6 digits are specified for the input data)
                                                                          ///< - Recommended check digit methods: #eCDUSPSPostnet
                                                                          ///< \n\n
  TECIT_HS("USPS PostNet9")                        eBC_USPSPostNet9    = 42,       ///< <b>USPS  PostNet ZIP+4 (5 digits + 4 digits) </b> \n Enumeration Value: 42
                                                                          ///< \n USPS Postnet symbol for encoding the ZIP+4 Code (5 digits ZIP code + 4 digits add-on)
                                                                          ///< \n Check digit is always calculated automatically and cannot be specified in the input data.
                                                                          ///< - Encodes 9 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUSPSPostnet
                                                                          ///< - Recommended check digit methods: #eCDUSPSPostnet
                                                                          ///< \n\n
  TECIT_HS("USPS PostNet10")                       eBC_USPSPostNet10   = 43,       ///< <b>USPS  PostNet ZIP+4 (5 digits + 4 digits + CD)</b> \n Enumeration Value: 43
                                                                          ///< \n USPS Postnet symbol for encoding the ZIP+4 Code (5 digits ZIP code + 4 digits add-on)
                                                                          ///< \n The required check digit is calculated automatically if length of input data equals 9; the user can also supply the 10th digit (no validation is performed).
                                                                          ///< - Encodes 9 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUSPSPostnet (if 9 digits are specified for the input data), #eCDNone (if 10 digits are specified for the input data)
                                                                          ///< - Recommended check digit methods: #eCDUSPSPostnet
                                                                          ///< \n\n
  TECIT_HS("USPS PostNet11")                       eBC_USPSPostNet11   = 44,       ///< <b>USPS  PostNet DPBC  (5 + 4 + 2 digits) </b> \n Enumeration Value: 44
                                                                          ///< \n USPS Postnet symbol for encoding the 11-digit Delivery Point Code (ZIP+4 followed by two DPBC numbers)
                                                                          ///< \n Check digit is always calculated automatically and cannot be specified in the input data.
                                                                          ///< - Encodes 11 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUSPSPostnet
                                                                          ///< - Recommended check digit methods: #eCDUSPSPostnet
                                                                          ///< \n\n
  TECIT_HS("USPS PostNet12")                  eBC_USPSPostNet12 = 45,     ///< <b> USPS PostNet DPBC  (5 + 4 + 2 digits + CD) </b> \n Enumeration Value: 45
                                                                          ///< \n USPS Postnet symbol for encoding the 11-digit Delivery Point Code (ZIP+4 followed by two DPBC numbers)
                                                                          ///< \n The required check digit is calculated automatically if length of input data equals 11 - on demand the user can also supply the 12th digit (no validation is performed).
                                                                          ///< - Encodes 11 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDUSPSPostnet (if 11 digits are specified for the input data), #eCDNone (if 12 digits are specified for the input data)
                                                                          ///< - Recommended check digit methods: #eCDUSPSPostnet
                                                                          ///< \n\n
  TECIT_HS("Plessey")                         eBC_Plessey     = 46,       ///< <b> Plessey Code </b> \n Enumeration Value: 46
                                                                          ///< - Codeable characters: ["0"-"9", "A"-"Z"]
                                                                          ///< - Default check-digit method: #eCDPlessey (2 check characters are created)
                                                                          ///< - Recommended check digit methods: #eCDPlessey
                                                                          ///< \n\n
  TECIT_HS("MSI")                             eBC_MSI         = 47,       ///< <b> MSI Plessey Code </b> \n Enumeration Value: 47
                                                                          ///< \n MSI is available with 1 or 2 check digits (both are mod-10 based).
                                                                          ///< - Encodes 11 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDMSI1
                                                                          ///< - Recommended check digit methods: #eCDMSI1 (mod-10) or #eCDMSI2 (mod10 + mod10)
                                                                          ///< \n\n
  TECIT_HS("SSCC-18")                         eBC_SSCC18      = 48,       ///< <b> Serial Shipping Container Code 18 </b>  \n Enumeration Value: 48
                                                                          ///< \n Used to encode the 18 digit Serial Shipping Container Code based upon the UCC/EAN-128 symbology with Application Identifier (AI) prefix of "00"
                                                                          ///< \n The check digit is encoded automatically if 17 digits are used for input data
                                                                          ///< \n The leading AI "00" is encoded automatically by TBarCode (exclude it from input data!).
                                                                          ///< - Encodes 2 digits "00" + 17 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDMod10 (if 17 digits are specified for the input data), #eCDNone (if 18 digits are specified for the input data)
                                                                          ///< - Recommended check digit methods: #eCDMod10
                                                                          ///< \n\n
  TECIT_HS("FIM")                             eBC_FIM         = 49,       ///< <b> FIM (Facing Indication Mark) </b> \n Enumeration Value: 49
                                                                          ///< \n NOT SUPPORTED BY THE CURRENT VERSION.
                                                                          ///< \n
  TECIT_HS("LOGMARS")                         eBC_LOGMARS     = 50,       ///< <b> LOGMARS </b> \n Enumeration Value: 50
                                                                          ///< \n Standardization of Code39 for military use  - please refer to Code 39 (#eBC_3OF9).
                                                                          ///< \n
  TECIT_HS("Pharmacode One-Track")            eBC_Pharma1     = 51,       ///< <b> Pharmacode (one-track) </b> \n Enumeration Value: 51
                                                                          ///< \n For medicine packing in pharmaceutically area (specification by Laetus).
                                                                          ///< - Codeable characters: ["0" - "9"] or generic encoding
                                                                          ///< - Default check-digit method: #eCDNone
                                                                          ///< - Recommended check digit methods: #eCDNone
                                                                          ///< \n\n
  TECIT_HS("PZN")                             eBC_PZN         = 52,       ///< <b> PZN (Pharma Zentral Nummer Germany) </b>\n Enumeration Value: 52
                                                                          ///< \n PZN uses Code 39 as base symbology; It has a special check digit and the human readable text contains always the prefix "PZN-" (which is not encoded in the bar code data)
                                                                          ///< \n The required check digit is calculated automatically if 6 input digits are supplied.
                                                                          ///< - Encodes 6 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDPZN (if 6 digits specified for the input data), #eCDNone (if 7 digits specified for the input data)
                                                                          ///< - Recommended check digit methods: #eCDPZN
                                                                          ///< \n\n
  TECIT_HS("Pharmacode Two-Track")            eBC_Pharma2     = 53,       ///< <b> Pharmacode (two-track) </b>\n Enumeration Value: 53
                                                                          ///< \n For medicine packing in pharmaceutically area (specification by Laetus); in opposition to #eBC_Pharma1 the information is contained in the vertical position of the bars.
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDNone
                                                                          ///< - Recommended check digit methods: #eCDNone
                                                                          ///< \n\n
  TECIT_HS("General Parcel")                  eBC_GP          = 54,       ///< <b> General Parcel </b>\n Enumeration Value: 54
                                                                          ///< \n NOT SUPPORTED BY THE CURRENT VERSION.
                                                                          ///< \n
  TECIT_HS("PDF417")                          eBC_PDF417      = 55,       ///< <b> PDF417 </b>\n Enumeration Value: 55
                                                                          ///< \n 2D symbology (multi-row) to encode large quantities of data
                                                                          ///< In default mode, input data is analyzed by TBarCode and best internal data compaction mode is switched (or shifted) automatically
                                                                          ///< \n Error correction and recognition is included in the code.
                                                                          ///< - A quiet zone of 2 modules at left and right side is added automatically
                                                                          ///< - Codeable characters: Alphanumeric (ASCII 0-255) and/or Bytes
                                                                          ///< - Default check-digit method: None
                                                                          ///< - Recommended check digit methods: None (Error correction and recognition depends on adjusted ECLevel)
                                                                          ///< \n\n
  TECIT_HS("PDF417 Truncated")                eBC_PDF417Trunc = 56,       ///< <b> PDF417 Truncated </b> \n Enumeration Value: 56
                                                                          ///< \n Similar to PDF417 but with synchronisation bars only on the left side of the symbol
                                                                          ///< \n Refer to #eBC_PDF417 for details.
                                                                          ///< \n
  TECIT_HS("MaxiCode")                        eBC_MAXICODE    = 57,       ///< <b> Maxi Code </b>\n Enumeration Value: 57
                                                                          ///< \n MaxiCode is a two-dimensional code, created by UPS for high-speed sortation and tracking of unit loads and transport packages
                                                                          ///< \n Modes for including postal information (SCM) can be adjusted; Printing size is set to a norm value (can be changed with BCSetModWidth())
                                                                          ///< \n Error correction and recognition is included in the code.
                                                                          ///< - Codeable characters: alphanumeric and/or Bytes
                                                                          ///< - Default encoding mode: Mode-4 (standard symbol)
                                                                          ///< - Available modes for UPS: Mode 2 (SCM Numeric) and Mode 3 (SCM alphanumeric) - see BCSet_Maxi_Mode()
                                                                          ///< \n\n
  TECIT_HS("QR-Code")                         eBC_QRCode      = 58,       ///< <b> QR-Code </b>\n Enumeration Value: 58
                                                                          ///< \n 2D symbology to encode large quantities of data (implemented QR-Code model: 2)
                                                                          ///< \n The symbol version (size) adjusts automatically depending on input data or can be set to a specific value (BCSet_QR_Version()); Special industry formats are supported (BCSet_QR_Format())
                                                                          ///< \n Error correction and recognition is included in the code, support for Kanji characters can be enabled.
                                                                          ///< - Codeable characters: alphanumeric and/or Bytes, Kanji char set (Shift JIS X 0208)
                                                                          ///< - Default check-digit method: None
                                                                          ///< - Recommended check digit methods: None (Error correction and recognition depends on adjusted Error Correction Level)
                                                                          ///< \n\n
  TECIT_HS("Code128A")                        eBC_Code128A    = 59,       ///< <b> Code128 Subset A </b> \n Enumeration Value: 59
                                                                          ///< \n Same as #eBC_Code128 but symbology subset starts with A (instead of automatic determination).
                                                                          ///< \n
  TECIT_HS("Code128B")                        eBC_Code128B    = 60,       ///< <b> Code128 Subset B </b>\n Enumeration Value: 60
                                                                          ///< \n Same as #eBC_Code128 but symbology subset starts with B (instead of automatic determination).
                                                                          ///< \n
  TECIT_HS("Code128C")                        eBC_Code128C    = 61,       ///< <b> Code128 Subset C </b>\n Enumeration Value: 61
                                                                          ///< \n Same as #eBC_Code128 but symbology subset starts with C (instead of automatic determination).
                                                                          ///< \n
  TECIT_HS("Code 93 Full ASCII")              eBC_9OF3A       = 62,       ///< <b> Code 93  Ascii </b>\n Enumeration Value: 62
                                                                          ///< \n Extended version of Code 93 (#eBC_9OF3), which allows encoding of the full ASCII char set.
                                                                          ///< - Codeable characters: ASCII 0x00 - 0x7f (0-127)
                                                                          ///< - Default checksum method: #eCD2Mod47 (2 mod-47 checksum characters, which are always part of the generated code)
                                                                          ///< - Recommended checksum methods: #eCD2Mod47
                                                                          ///< \n\n
  TECIT_HS("Australian Post Custom")          eBC_AusPostCustom = 63,     ///< <b> Australian Post standard customer barcode </b>\n Enumeration Value: 63
                                                                          ///< \n Encodes the 8 digit Delivery Point Identifier (DPID) used by the Australian Post for mail sorting
                                                                          ///< \n Reed Solomon Error correction according to symbology specification is added automatically by TBarCode.
                                                                          ///< - Encodes 8 digits
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default and recommended check-digit method: None
                                                                          ///< \n\n
  TECIT_HS("Australian Post Custom2")         eBC_AusPostCustom2 = 64,    ///< <b> Australian Post customer barcode 2 </b>\n Enumeration Value: 64
                                                                          ///< \n Encodes the 8 digit Delivery Point Identifier (DPID) followed by customer information (up to 5 characters)
                                                                          ///< \n Encodes 8 digits + 5 customer data characters + Reed Solomon Error Correction
                                                                          ///< \n Reed Solomon Error correction according to symbology specification is added automatically by TBarCode.
                                                                          ///< - Codeable characters DPID: ["0" - "9"]
                                                                          ///< - Codeable characters customer data: ["0" - "9", "A" - "Z", "a" - "z", Space, "#"] according to C Encoding Table in the Australian Post bar code specification (Table N is not supported in the current version of TBarCode)
                                                                          ///< - Default and recommended check-digit method: None
                                                                          ///< \n\n
  TECIT_HS("Australian Post Custom3")         eBC_AusPostCustom3 = 65,    ///< <b> Australian Post customer barcode 3 </b>\n Enumeration Value: 65
                                                                          ///< \n Encodes the 8 digit Delivery Point Identifier (DPID) followed by customer information (up to 10 characters)
                                                                          ///< \n Reed Solomon Error correction according to symbology specification is added automatically by TBarCode.
                                                                          ///< - Encodes 8 digits + 10 customer data characters
                                                                          ///< - Codeable characters DPID: ["0" - "9"]
                                                                          ///< - Codeable characters customer data: ["0" - "9", "A" - "Z", "a" - "z", Space, "#"] according to C Encoding Table in the Australian Post bar code specification (Table N is not supported in the current version of TBarCode)
                                                                          ///< - Default and recommended check-digit method: None
                                                                          ///< \n\n
  TECIT_HS("Australian Post Reply Paid")      eBC_AusPostReplyPaid = 66,  ///< <b> Australian Post Reply Paid barcode </b>\n Enumeration Value: 66
                                                                          ///< \n Encodes the 8 digit Sorting Code (DPID) used by the Australian Post, Format Control Code is set to 45 (Reply Paid Barcode)
                                                                          ///< \n Reed Solomon Error correction according to symbology specification is added automatically by TBarCode.
                                                                          ///< - Encodes 8 digits
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default and recommended check-digit method: None
                                                                          ///< \n\n
  TECIT_HS("Australian Post Routing")         eBC_AusPostRouting = 67,   ///< <b> Australian Post Routing barcode </b>\n Enumeration Value: 67
                                                                          ///< \n Encodes the 8 digit Sorting Code (DPID) used by the Australian Post, Format Control Code is set to 87 (Routing Barcode)
                                                                          ///< \n Reed Solomon Error correction according to symbology specification is added automatically by TBarCode.
                                                                          ///< - Encodes 8 digits
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default and recommended check-digit method: None
                                                                          ///< \n\n
  TECIT_HS("Australian Post Redirect")        eBC_AusPostRedirect = 68,   ///< <b> Australian Post Redirection barcode </b>\n Enumeration Value: 68
                                                                          ///< \n Encodes the 8 digit Sorting Code (DPID) used by the Australian Post, Format Control Code is set to 92 (Redirection Barcode)
                                                                          ///< \n Reed Solomon Error correction according to symbology specification is added automatically by TBarCode.
                                                                          ///< - Encodes 8 digits
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default and recommended check-digit method: #eCDNone
                                                                          ///< \n\n
  TECIT_HS("ISBN")                            eBC_ISBN        = 69,       ///< <b> ISBN </b>\n Enumeration Value: 69
                                                                          ///< \n ISBN is used for encoding the ISBN number (used in the book industry) into a bar code for retail and wholesale applications
                                                                          ///< \n ISBN is based upon an EAN-13 P5 symbology (see #eBC_EAN13P5), the required check digit is calculated automatically if length of input data equals 17.
                                                                          ///< - Encodes 17 digits (12 + 5) and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDEAN13 (if 17 digits are specified for the input data), #eCDNone (if 18 digits are specified for the input data)
                                                                          ///< - Recommended check digit methods: #eCDEAN13
                                                                          ///< \note Strip off the check digit from the ISBN number before you encode it into the symbol (otherwise you get a wrong bar code!)
                                                                          ///< \n\n
  TECIT_HS("Royal Mail 4 State (RM4SCC)")     eBC_RM4SCC      = 70,       ///< <b> Royal Mail 4 State customer code (RM4SCC)</b>\n Enumeration Value: 70
                                                                          ///< \n Used for automated mail sorting and addressing in the UK
                                                                          ///< \n Encodes a variable amount of characters followed by an internal calculated check-digit.
                                                                          ///< - Codeable characters: ["0" - "9", "A" - "Z"]
                                                                          ///< - Default check-digit method: #eCDRM4SCC (the required check character is added automatically by TBarCode)
                                                                          ///< - Recommended check digit methods: #eCDRM4SCC
                                                                          ///< \n\n
  TECIT_HS("Data Matrix")                     eBC_DataMatrix  = 71,       ///< <b> Data Matrix </b>\n Enumeration Value: 71
                                                                          ///< \n 2D matrix symbology developed to encode large quantities of data (especially on small objects), size adjusts automatically depending on input data (BCSet_DM_Size())
                                                                          ///< \n Symbology internal error correction (based upon ECC200) is added by TBarCode automatically
                                                                          ///< \n Input data is analyzed by TBarCode and the best suitable compaction mode is switched/shifted to during encoding.
                                                                          ///< - Encodes variable amount of data (up to 1556 Bytes or 2335 alpha numeric characters)
                                                                          ///< - Codeable characters: Alphanumeric and/or Bytes
                                                                          ///< - Default and recommended check-digit method: None (check digit and error correction is included in the code)
                                                                          ///< - Recommended check digit methods: None
                                                                          ///< \n\n
  TECIT_HS("EAN14")                           eBC_EAN14       = 72,       ///< <b> EAN-14 </b>\n Enumeration Value: 72
                                                                          ///< \n Used to encode the GTIN (Global Trade Item Number) with Application Identifier (AI) 01
                                                                          ///< \n Within the EAN UCC System you can use 2 symbologies for encoding the GTIN: UCC/EAN-128 and ITF-14 (Code 2 of 5 interleaved with 14 digits)
                                                                          ///< \n Here we use EAN-128 with AI 01, the AI must not be part of the input data (it is prefixed automatically)
                                                                          ///< \n The check digit is calculated automatically if not specified in the input data (that is when only 13 digits are used).
                                                                          ///< - Codeable characters: see EAN128 (#eBC_EAN128)
                                                                          ///< - Default check-digit method: #eCDEAN14
                                                                          ///< - Recommended check digit methods: #eCDEAN14
                                                                          ///< \n\n
  TECIT_HS("CODABLOCK-E")                     eBC_CODABLOCK_E = 73,       ///< <b> CODABLOCK-E </b>\n Enumeration Value: 73
                                                                          ///< \n NOT SUPPORTED IN THE CURRENT VERSION.
                                                                          ///< \n
  TECIT_HS("CODABLOCK-F")                     eBC_CODABLOCK_F = 74,       ///< <b> CODABLOCK-F </b>\n Enumeration Value: 74
                                                                          ///< \n Stacked version of Code128 symbology, each row is a single Code 128 symbol extended with row indicator information and additional check digits
                                                                          ///< \n The UCC/EAN format indicator is supported (BCSet_CBF_Format()).
                                                                          ///< - Encodes variable amount of data
                                                                          ///< - Codeable characters: ASCII 0-127 + ISO 8859-1
                                                                          ///< - Default check-digit method: internal check digit method
                                                                          ///< - Recommended check digit methods: None (internal check digit method)
                                                                          ///< \n\n
  TECIT_HS("NVE-18")                          eBC_NVE18       = 75,       ///< <b> NVE-18 (Nummer der Versandeinheit) </b>\n Enumeration Value: 75
                                                                          ///< \n Alias SSCC-18 - see #eBC_SSCC18.
                                                                          ///< \n
  TECIT_HS("Japanese Postal")                 eBC_JapanesePostal  = 76,   ///< <b> Japanese Postal customer code </b>\n Enumeration Value: 76
                                                                          ///< \n For customers of the Japanese Postal Service. You can encode the ZIP code followed by block and street number (Address-B data field) 
                                                                          ///< \n Address B data compaction can be enabled with Format Parameter "J" (BCSetFormat())); If format ist set to "J", Japanese characters and also Chinese street numbers (encoded with Shift JIS char set) are converted to the Address-B data field by using the specified algorithm from the Japanese Postal Service.
                                                                          ///< - Encodes 7 digits (ZIP code) + additional data
                                                                          ///< - Codeable characters ZIP Code: ["0" - "9"]
                                                                          ///< - Codeable characters additional data: ["0" - "9", "A" - "Z", "-"] (Shift JIS characters are compacted if format "J" is set)
                                                                          ///< - Default check-digit method: None (the symbology internal check character is created automatically by TBarCode)
                                                                          ///< - Recommended check digit methods: None
                                                                          ///< \n\n
  TECIT_HS("Korean Postal Authority")         eBC_KoreanPostalAuth= 77,   ///< <b> Korean Postal Authority code </b>\n Enumeration Value: 77
                                                                          ///< \n Used by the Korean Postal Service for mail sorting
                                                                          ///< \n The symbology uses a special mod-10 based check digit, check digit calculation is enabled/disabled depending on the number of input characters.
                                                                          ///< - Encodes 6 digits + 1 check digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDMod10Kor (if 6 digits are provided as for the input data), eCDNone (if 7 digits are provided)
                                                                          ///< - Recommended check digit methods: #eCDMod10Kor
                                                                          ///< \n\n
  TECIT_HS("RSS-14 Truncated")                eBC_RSS14Trunc   = 78,      ///< <b> RSS-14 Truncated </b>\n Enumeration Value: 78
                                                                          ///< \n Similar to RSS-14 (#eBC_RSS14) but with reduced height (should be at least 13X; X = module width), omni-directional scanning may not be possible with truncated version, no quiet zone is needed for the RSS code family.
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n
  TECIT_HS("RSS-14 Stacked")                  eBC_RSS14Stacked = 79,      ///< <b> RSS-14 Stacked </b>\n Enumeration Value: 79
                                                                          ///< \n Similar to RSS-14 (#eBC_RSS14) but split into 2 rows to make the symbol smaller, used for pharmaceutical packaging.
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n
  TECIT_HS("RSS-14 Stacked Omnidir")          eBC_RSS14StackedOmni = 80,  ///< <b> RSS-14 Stacked Omnidirectional </b>\n Enumeration Value: 80
                                                                          ///< \n This version of RSS-14 Stacked (#eBC_RSS14Stacked) supports omni-directional scanning, the increased symbol height makes this possible.
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n
  TECIT_HS("RSS Expanded Stacked")            eBC_RSSExpStacked    = 81,  ///< <b> RSS Expanded Stacked </b>\n Enumeration Value: 81
                                                                          ///< \n Stacked version of RSS Expanded (#eBC_RSSExp), the number of data segments per row can vary between 4 and 22 (can be set with BCSet_RSS_SegmPerRow() - default segmentation is 4).
                                                                          ///< \note Available as EAN.UCC Composite Symbology
                                                                          ///< \n\n
  TECIT_HS("Planet 12 digit")                 eBC_Planet12     = 82,      ///< <b> Planet Code 12 (2 + 5 + 4 digits + 1 CD Mod10) </b>\n Enumeration Value: 82
                                                                          ///< \n Used by the USPS (US Postal Service) for tracking inbound and outbound letter mail
                                                                          ///< \n The required check digit is calculated automatically by TBarCode if length of input data equals 11.
                                                                          ///< - Encodes 11 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDMod10Pla (if 11 digits are specified for the input data), #eCDNone (if 12 digits are specified for the input data)
                                                                          ///< - Recommended check digit methods: #eCDMod10Pla
                                                                          ///< \n\n
  TECIT_HS("Planet 14 digit")                 eBC_Planet14     = 83,      ///< <b> Planet Code 14 (2 + 5 + 6 digits + 1 CD Mod10) </b>\n Enumeration Value: 83
                                                                          ///< \n Used by the USPS (US Postal Service) for tracking inbound and outbound letter mail
                                                                          ///< \n The required check digit is calculated automatically by TBarCode if length of input data equals 13.
                                                                          ///< - Encodes 13 digits and 1 check-digit
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDMod10Pla (if 13 digits are specified for the input data), #eCDNone (if 14 digits are specified for the input data)
                                                                          ///< - Recommended check digit methods: #eCDMod10Pla
                                                                          ///< \n\n
  TECIT_HS("MicroPDF417")                     eBC_MicroPDF417  = 84,      ///< <b> MicroPDF417 </b>\n Enumeration Value: 84
                                                                          ///< \n 2D / multi-row symbology to encode large quantities of data; Micro PDF is based upon PDF417 (#eBC_PDF417) but with specific variants of rows and columns - called "version" (BCSet_MPDF417_Version())
                                                                          ///< In default mode, input data is analyzed by TBarCode and best internal data compaction mode is selected (and dynamically switched) automatically
                                                                          ///< \n Error correction and recognition is included in the code.
                                                                          ///< - A quiet zone of 1 module at left and right side is added automatically
                                                                          ///< - Encodable characters: alphanumeric (ASCII 0-255) and/or Bytes
                                                                          ///< - Default check-digit method: None
                                                                          ///< - Recommended check digit methods: None (number of error correction codewords is adapted to symbol version according to specification)
                                                                          ///< \n\n
  TECIT_HS("USPS OneCode (4-CB)")             eBC_USPSOneCode4CB= 85,     ///< <b> USPS OneCode (4-State Customer Barcode)</b>\n Enumeration Value: 85                                                                          
                                                                          ///< \n Height modulated bar code used for automated mail sorting and addressing by USPS.
																		                                      ///< \n Encodes a 20, 25, 29 or 31 digit string: 20 digits Tracking Code followed by the Routing Code (= ZIP Code with 0, 5, 9, or 11 digits).
                                                                          ///< The second digit must be "0" - "4".
                                                                          ///< - Codeable characters: ["0" - "9"]
                                                                          ///< - Default check-digit method: #eCDNone (the symbology specific check digit is added automatically by TBarCode)
                                                                          ///< - Recommended check digit methods: #eCDNone
                                                                          ///< \n\n
  TECIT_HS("Plessey Bidirectional")           eBC_PlesseyBidir  = 86,     ///< <b> Plessey Code with bidirectional reading support</b> \n Enumeration Value: 86
                                                                          ///< \n
                                                                          ///< - Codeable characters: ["0"-"9", "A"-"Z"]
                                                                          ///< - Default check-digit method: #eCDPlessey (2 check characters are created)
                                                                          ///< - Recommended check digit methods: #eCDPlessey
                                                                          ///< \n\n

  /* not implemented yet
  TECIT_HS("Italian Postal 2 of 5")           eBC_ItalianPostal2Of5 = xx, ///< <b>Italian Postal 2 of 5 </b>\n Enumeration Value: xx
                                                                          ///< \n NOT SUPPORTED IN THE CURRENT VERSION.
                                                                          ///< \n
  TECIT_HS("Italian Postal 3 of 9")           eBC_ItalianPostal3Of9 = xx, ///< <b>Italian Postal 3 of 9 </b>\n Enumeration Value: xx
                                                                          ///< \n NOT SUPPORTED IN THE CURRENT VERSION.
                                                                          ///< \n
  KIX
  */
																			
} e_BarCType;


//----------------------------------------------------------------------------
///  Supported check-digit methods.
///  Enumerations for all supported check-digit methods 
//----------------------------------------------------------------------------
typedef enum    /*tag_CDMethod*/
{
    TECIT_HS("None")                                eCDNone         = 0,     ///< =0: No check digit calculation is performed      
    TECIT_HS("Standard")                            eCDStandard     ,        ///< =1: Standard check digit of barcode type will be used
    TECIT_HS("Modulo 10")                           eCDMod10        ,        ///< =2: Modulo 10 (usually used with Interleaved 2of5)                                             
    TECIT_HS("Modulo 43")                           eCDMod43        ,        ///< =3: Modulo 43 (suggested for Code39 and Logmars, consist of 1 digit)                                             
    TECIT_HS("Modulo 47 (2 digits)")                eCD2Mod47       ,        ///< =4: Modulo 47 (2 digits)                                             
    TECIT_HS("DP Leitcode")                         eCDDPLeit       ,        ///< =5: Method for DP Leitcode                                             
    TECIT_HS("DP Identcode")                        eCDDPIdent      ,        ///< =6: Method for DP Identcode                                             
    TECIT_HS("Code11 (1 digit)")                    eCD1Code11      ,        ///< =7: Method for Code11 (1 digit)                                             
    TECIT_HS("Code11 (2 digits)")                   eCD2Code11      ,        ///< =8: Method for Code11 (2 digits)                                             
    TECIT_HS("USPS Postnet")                             eCDUSPSPostnet      ,        ///< =9: Method for USPS Postnet                                             
    TECIT_HS("MSI (1 digit)")                       eCDMSI1         ,        ///< =10: Method for MSI (1 digit)                                             
    TECIT_HS("MSI (2 digits)")                      eCDMSI2         ,        ///< =11: Method for MSI (2 digits)                                             
    TECIT_HS("Plessey")                             eCDPlessey      ,        ///< =12: Method for Plessey                                             
    TECIT_HS("EAN 8")                               eCDEAN8         ,        ///< =13: Method for EAN 8                                             
    TECIT_HS("EAN 13")                              eCDEAN13        ,        ///< =14: Method for EAN 13                                              
    TECIT_HS("UPC A")                               eCDUPCA         ,        ///< =15: Method for UPC A                                             
    TECIT_HS("UPC E")                               eCDUPCE         ,        ///< =16: Method for UPC E                                             
    TECIT_HS("EAN 128")                             eCDEAN128       ,        ///< =17: EAN 128 internal method (Modulo 103)                                             
    TECIT_HS("Code 128")                            eCDCode128      ,        ///< =18: Code 128 internal method (Modulo 103)                                             
    TECIT_HS("Royal Mail 4 State")                  eCDRM4SCC       ,        ///< =19: Method for Royal Mail 4 State                                             
    TECIT_HS("Mod-11 (PZN)")                        eCDPZN          ,        ///< =20: Mod 11 Method for PZN.
    TECIT_HS("Mod-11 (W=7)")                        eCDMod11W7      ,        ///< =21: Mod 11 (using weight 7)
    TECIT_HS("EAN 14")                              eCDEAN14        ,        ///< =22: Method for EAN 14
    TECIT_HS("Modulo 10 (Korean PA)")               eCDMod10Kor     ,        ///< =23: Method for Korean Postal Authority (Modulo 10 based)
    TECIT_HS("Modulo 10 (Planet)")                  eCDMod10Pla     ,        ///< =24: Method for Planet (Modulo 10 based)
    TECIT_HS("Modulo 10 (Italian Postal 2/5)")      eCDMod10ItlPst25,        ///< =25: Method for Italian Postal 2/5 (Modulo 10 based)
    TECIT_HS("Modulo 36 (DPD Barcode)")             eCDMod36,                ///< =26: Mod 36 (ISO/IES 7064) for DPD Barcode
} e_CDMethod;


//----------------------------------------------------------------------------
///  Supported barcode rotations.
///  Enumerations for all supported barcode rotations (counter-clockwise) 
//----------------------------------------------------------------------------
typedef enum /*tag_Degree*/
{
    TECIT_HS("0 degrees")                           deg0            = 0,    ///< =0: No rotation
    TECIT_HS("90 degrees")                          deg90           = 1,    ///< =1: 90 rotated counter-clockwise
    TECIT_HS("180 degrees")                         deg180          = 2,    ///< =2: 180 rotated counter-clockwise (bottom-up)
    TECIT_HS("270 degrees")                         deg270          = 3     ///< =3: 270 rotated counter-clockwise
}
e_Degree;


//----------------------------------------------------------------------------
///  Supported measurement units.
///  Enumerations for all supported measurement units 
//----------------------------------------------------------------------------
typedef enum /*tag_MUnit*/
{                                                   
    TECIT_HS("Default")                             eMUDefault      = 0,    ///< =0: Use units from the given device contect (DC)
    TECIT_HS("Pixel")                               eMUPixel        ,       ///< =1: Values are specified in Pixels 
    TECIT_HS("mm")                                  eMUMM           ,       ///< =2: Values are specified in Millimeter (mm) 
} e_MUnit;


//----------------------------------------------------------------------------
///  Supported measurement units for Quiet Zones.
//----------------------------------------------------------------------------
typedef enum /*tag_QZMUnit*/
{                                                   
    TECIT_HS("No quiet zone")                       eQZMUNone       = 0,    ///< =0: Use implemented default quiet-zone (mostly no quiet-zone)
    TECIT_HS("Modules")                             eQZMUModules,           ///< =1: Quiet-Zone is specified in number of modules
    TECIT_HS("mm")                                  eQZMUMM     ,           ///< =2: Not implemented
    TECIT_HS("mils")                                eQZMUMils   ,           ///< =3: Not implemented
    TECIT_HS("Pixel")                               eQZMUPixel  ,           ///< =4: Not implemented
} e_QZMUnit;

//----------------------------------------------------------------------------
///  Supported bearer bar types.
///  Enumerations for all supported bearer bar types
//----------------------------------------------------------------------------
typedef enum /*tag_BearerBar*/
{       
  /// =0: No bearer bar.
  TECIT_HS("None (Default)") eBearerBar_None = 0, 

  /// =1: Bearer Bar is drawn on top and bottom of the bar code.
  TECIT_HS("Horizontal") eBearerBar_Horizontal = 1, 

  /// =2: Bearer Bar is drawn on all sides of the bar code.
  TECIT_HS("Rectangle") eBearerBar_Rectangle = 2,       
} e_BearerBar;

//----------------------------------------------------------------------------
///  Supported image output formats.
//----------------------------------------------------------------------------
typedef enum /*tag_ImageType*/
{
    TECIT_HS("BMP")                                 eIMBmp          = 0,    ///< =0: BMP-Image
    TECIT_HS("EMF")                                 eIMEmf          ,       ///< =1: EMF-File (not supported in ConvertToStream and ConvertToStreamEx)
    TECIT_HS("EPS")                                 eIMEps          ,       ///< =2: EPS-Bitmap-Image (not supported in ConvertToStream and ConvertToStreamEx)
    TECIT_HS("GIF")                                 eIMGif          ,       ///< =3: GIF-Image 
    TECIT_HS("JPG")                                 eIMJpg          ,       ///< =4: JPG-Image
    TECIT_HS("PCX")                                 eIMPcx          ,       ///< =5: PCX-Image (not supported in ConvertToStream and ConvertToStreamEx)
    TECIT_HS("PNG")                                 eIMPng          ,       ///< =6: PNG-Image
    TECIT_HS("TIF")                                 eIMTif          ,       ///< =7: TIF-Image
    TECIT_HS("EPS-VECTOR")                          eIMEpsVector    ,       ///< =8: EPS-Vector-Image (not supported in ConvertToStream and ConvertToStreamEx)
} e_IMType;


//----------------------------------------------------------------------------
///  Supported alignments for the human readable text.
//----------------------------------------------------------------------------
typedef enum /*tag_Align*/
{
    TECIT_HS("Default")                             eAlDefault      ,       ///< =0: Default alignment (centered)
    TECIT_HS("Left")                                eAlLeft         ,       ///< =1: Text is left-aligned 
    TECIT_HS("Right")                               eAlRight        ,       ///< =2: Text is right-aligned 
    TECIT_HS("Center")                              eAlCenter       ,       ///< =3: Text is centered
} e_BCAlign;


//----------------------------------------------------------------------------
//
//  License Enumerations
//
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
///  Available product variants.
///  Product variants used for licensing 
//----------------------------------------------------------------------------
#ifdef TEC_UNIX
  typedef enum /*tag_licProduct*/
  {
    TECIT_HS("Invalid product ID")                  eLicInvalid = -1,      ///< =-1: No valid product-id
    TECIT_HS("TBarCode 1D (standard)")              eLicProd1D = 105,      ///< =105: Generates linear barcodes only
    TECIT_HS("TBarCode 2D (1D + 2D symbolgies)")    eLicProd2D = 106,      ///< =106: Generates linear AND 2D codes
  }
  e_licProduct;
#elif defined(TEC_WINCE)
  typedef enum /*tag_licProduct*/
  {
    TECIT_HS("Invalid product ID")                  eLicInvalid = -1,      ///< =-1: No valid product-id
    TECIT_HS("TBarCode 1D (standard)")              eLicProd1D = 24,       ///< =24: Generates linear barcodes only
    TECIT_HS("TBarCode 2D (1D + 2D symbologies)")   eLicProd2D = 25,       ///< =25: Generates linear AND 2D codes
  }
  e_licProduct;
#else /* WINDOWS */
  typedef enum /*tag_licProduct*/
  {
    TECIT_HS("Invalid product ID")                  eLicInvalid = -1,      ///< =-1: No valid product-id
    TECIT_HS("TBarCode 1D (standard)")              eLicProd1D = 22,       ///< =22: Generates linear barcodes only
    TECIT_HS("TBarCode 2D (1D + 2D symbologies)")   eLicProd2D = 23,       ///< =23: Generates linear AND 2D codes
  }
  e_licProduct;
#endif
  

//----------------------------------------------------------------------------
//
//  Product
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
///  Available license variants.
//----------------------------------------------------------------------------
typedef enum /*tag_licKind*/
{
    TECIT_HS("Single (Einzellizenz)")               eLicKindSingle = 1,         ///< =1: Single license for exactly one computer
    TECIT_HS("Site (Firmenlizenz)")                 eLicKindSite = 2,           ///< =2: Site license for an arbitrary number of computers  within one site (or one facility) at one legal address
    TECIT_HS("Developer (Entwicklerlizenz)")        eLicKindDeveloper = 3,      ///< =3: Developer license for redistribution to 3rd party
    TECIT_HS("Web (Weblizenz)")                     eLicKindWeb = 3,            ///< =3: Web-server license
}
e_licKind;


//----------------------------------------------------------------------------
///  Available symbol-sizes for DataMatrix.
//----------------------------------------------------------------------------
typedef enum /*tagE_DMSizes*/
{
    TECIT_HS("Default")                             eDMSz_Default,  ///< =0: Compute size of Data Matrix symbol automatically
    // Squares                                      
    TECIT_HS("10  x 10")                            eDMSz_10x10,    ///< =1: Fixed square symbol-size  10 x  10
    TECIT_HS("12  x 12")                            eDMSz_12x12,    ///< =2: Fixed square symbol-size  12 x  12
    TECIT_HS("14  x 14")                            eDMSz_14x14,    ///< =3: Fixed square symbol-size  14 x  14
    TECIT_HS("16  x 16")                            eDMSz_16x16,    ///< =4: Fixed square symbol-size  16 x  16
    TECIT_HS("18  x 18")                            eDMSz_18x18,    ///< =5: Fixed square symbol-size  18 x  18
    TECIT_HS("20  x 20")                            eDMSz_20x20,    ///< =6: Fixed square symbol-size  20 x  20
    TECIT_HS("22  x 22")                            eDMSz_22x22,    ///< =7: Fixed square symbol-size  22 x  22
    TECIT_HS("24  x 24")                            eDMSz_24x24,    ///< =8: Fixed square symbol-size  24 x  24
    TECIT_HS("26  x 26")                            eDMSz_26x26,    ///< =9: Fixed square symbol-size  26 x  26
    TECIT_HS("32  x 32")                            eDMSz_32x32,    ///< =10: Fixed square symbol-size  32 x  32
    TECIT_HS("36  x 36")                            eDMSz_36x36,    ///< =11: Fixed square symbol-size  36 x  36
    TECIT_HS("40  x 40")                            eDMSz_40x40,    ///< =12: Fixed square symbol-size  40 x  40
    TECIT_HS("44  x 44")                            eDMSz_44x44,    ///< =13: Fixed square symbol-size  44 x  44
    TECIT_HS("48  x 48")                            eDMSz_48x48,    ///< =14: Fixed square symbol-size  48 x  48
    TECIT_HS("52  x 52")                            eDMSz_52x52,    ///< =15: Fixed square symbol-size  52 x  52
    TECIT_HS("64  x 64")                            eDMSz_64x64,    ///< =16: Fixed square symbol-size  64 x  64
    TECIT_HS("72  x 72")                            eDMSz_72x72,    ///< =17: Fixed square symbol-size  72 x  72
    TECIT_HS("80  x 80")                            eDMSz_80x80,    ///< =18: Fixed square symbol-size  80 x  80
    TECIT_HS("88  x 88")                            eDMSz_88x88,    ///< =19: Fixed square symbol-size  88 x  88
    TECIT_HS("96  x 96")                            eDMSz_96x96,    ///< =20: Fixed square symbol-size  96 x  96
    TECIT_HS("104 x 104")                           eDMSz_104x104,  ///< =21: Fixed square symbol-size 104 x 104
    TECIT_HS("120 x 120")                           eDMSz_120x120,  ///< =22: Fixed square symbol-size 120 x 120
    TECIT_HS("132 x 132")                           eDMSz_132x132,  ///< =23: Fixed square symbol-size 132 x 132
    TECIT_HS("144 x 144")                           eDMSz_144x144,  ///< =24: Fixed square symbol-size 144 x 144
    // Rectangles                                   
    TECIT_HS("8   x 18")                            eDMSz_8x18,     ///< =25: Fixed rectangular symbol-size   8 x 18
    TECIT_HS("8   x 32")                            eDMSz_8x32,     ///< =26: Fixed rectangular symbol-size   8 x 32
    TECIT_HS("12  x 26")                            eDMSz_12x26,    ///< =27: Fixed rectangular symbol-size  12 x 26
    TECIT_HS("12  x 36")                            eDMSz_12x36,    ///< =28: Fixed rectangular symbol-size  12 x 36
    TECIT_HS("16  x 36")                            eDMSz_16x36,    ///< =29: Fixed rectangular symbol-size  16 x 36
    TECIT_HS("16  x 48")                            eDMSz_16x48,    ///< =30: Fixed rectangular symbol-size  16 x 48
} e_DMSizes;


//----------------------------------------------------------------------------
///  Available encoding formats for Data Matrix.
//----------------------------------------------------------------------------
typedef enum /*tagE_DMFormat*/
{
    TECIT_HS("Default")                             eDMPr_Default,  ///< =0: Default mode : The standard format of Data Matrix without a special header.
    TECIT_HS("UCC/EAN")                             eDMPr_UCCEAN,   ///< =1: UCC/EAN mode : Special format defined by UCC and EAN for encoding Application Identifiers. This format adds the function character FNC1 at 1st position in the symbol.
    TECIT_HS("Industry")                            eDMPr_Industry, ///< =2: Industry mode: supports peculiar industry formats (adds FNC1 at 2nd position)
    TECIT_HS("Format 05")                           eDMPr_Macro05,  ///< =3: Macro 05 mode: [)>Rs05Gs is encoded at the beginning of the code
    TECIT_HS("Format 06")                           eDMPr_Macro06,  ///< =4: Macro 06 mode: [)>Rs06Gs is encoded at the beginning of the code
}  e_DMFormat;


//----------------------------------------------------------------------------
///  Available symbol-sizes for QR-Code.
//----------------------------------------------------------------------------
typedef enum 
/// @cond INCLUDE_IN_DOXY
tagE_QRVersion            // This shall not appear in doxygen. Would create a confusing typedef in the doxygen doc.
 /// @endcond 
{
    TECIT_HS("Default")                             eQRVers_Default,///< =0: Compute size of QR-Code symbol automatically
    TECIT_HS("(1) 21 x 21")                         eQRVers_1 ,     ///< =1: Fixed symbol-size 21 x 21 squares (Version 1)
    TECIT_HS("(2) 25 x 25")                         eQRVers_2 ,     ///< =2: Fixed symbol-size 25 x 25 squares (Version 2)
    TECIT_HS("(3) 29 x 29")                         eQRVers_3 ,     ///< =3: Fixed symbol-size 29 x 29 squares (Version 3)
    TECIT_HS("(4) 33 x 33")                         eQRVers_4 ,     ///< =4: Fixed symbol-size 33 x 33 squares (Version 4)
    TECIT_HS("(5) 37 x 37")                         eQRVers_5 ,     ///< =5: Fixed symbol-size 37 x 37 squares (Version 5)
    TECIT_HS("(6) 41 x 41")                         eQRVers_6 ,     ///< =6: Fixed symbol-size 41 x 41 squares (Version 6)
    TECIT_HS("(7) 45 x 45")                         eQRVers_7 ,     ///< =7: Fixed symbol-size 45 x 45 squares (Version 7)
    TECIT_HS("(8) 49 x 49")                         eQRVers_8 ,     ///< =8: Fixed symbol-size 49 x 49 squares (Version 8)
    TECIT_HS("(9) 53 x 53")                         eQRVers_9 ,     ///< =9: Fixed symbol-size 53 x 53 squares (Version 9)
    TECIT_HS("(10) 57 x 57")                        eQRVers_10,     ///< =10: Fixed symbol-size 57 x 57 squares (Version 10)
    TECIT_HS("(11) 61 x 61")                        eQRVers_11,     ///< =11: Fixed symbol-size 61 x 61 squares (Version 11)
    TECIT_HS("(12) 65 x 65")                        eQRVers_12,     ///< =12: Fixed symbol-size 65 x 65 squares (Version 12)
    TECIT_HS("(13) 69 x 69")                        eQRVers_13,     ///< =13: Fixed symbol-size 69 x 69 squares (Version 13)
    TECIT_HS("(14) 73 x 73")                        eQRVers_14,     ///< =14: Fixed symbol-size 73 x 73 squares (Version 14)
    TECIT_HS("(15) 77 x 77")                        eQRVers_15,     ///< =15: Fixed symbol-size 77 x 77 squares (Version 15)
    TECIT_HS("(16) 81 x 81")                        eQRVers_16,     ///< =16: Fixed symbol-size 81 x 81 squares (Version 16)
    TECIT_HS("(17) 85 x 85")                        eQRVers_17,     ///< =17: Fixed symbol-size 85 x 85 squares (Version 17)
    TECIT_HS("(18) 89 x 89")                        eQRVers_18,     ///< =18: Fixed symbol-size 89 x 89 squares (Version 18)
    TECIT_HS("(19) 93 x 93")                        eQRVers_19,     ///< =19: Fixed symbol-size 93 x 93 squares (Version 19)
    TECIT_HS("(20) 97 x 97")                        eQRVers_20,     ///< =20: Fixed symbol-size 97 x 97 squares (Version 20)
    TECIT_HS("(21) 101 x 101")                      eQRVers_21,     ///< =21: Fixed symbol-size 101 x 101 squares (Version 21)
    TECIT_HS("(22) 105 x 105")                      eQRVers_22,     ///< =22: Fixed symbol-size 105 x 105 squares (Version 22)
    TECIT_HS("(23) 109 x 109")                      eQRVers_23,     ///< =23: Fixed symbol-size 109 x 109 squares (Version 23)
    TECIT_HS("(24) 113 x 113")                      eQRVers_24,     ///< =24: Fixed symbol-size 113 x 113 squares (Version 24)
    TECIT_HS("(25) 117 x 117")                      eQRVers_25,     ///< =25: Fixed symbol-size 117 x 117 squares (Version 25)
    TECIT_HS("(26) 121 x 121")                      eQRVers_26,     ///< =26: Fixed symbol-size 121 x 121 squares (Version 26)
    TECIT_HS("(27) 125 x 125")                      eQRVers_27,     ///< =27: Fixed symbol-size 125 x 125 squares (Version 27)
    TECIT_HS("(28) 129 x 129")                      eQRVers_28,     ///< =28: Fixed symbol-size 129 x 129 squares (Version 28)
    TECIT_HS("(29) 133 x 133")                      eQRVers_29,     ///< =29: Fixed symbol-size 133 x 133 squares (Version 29)
    TECIT_HS("(30) 137 x 137")                      eQRVers_30,     ///< =30: Fixed symbol-size 137 x 137 squares (Version 30)
    TECIT_HS("(31) 141 x 141")                      eQRVers_31,     ///< =31: Fixed symbol-size 141 x 141 squares (Version 31)
    TECIT_HS("(32) 145 x 145")                      eQRVers_32,     ///< =32: Fixed symbol-size 145 x 145 squares (Version 32)
    TECIT_HS("(33) 149 x 149")                      eQRVers_33,     ///< =33: Fixed symbol-size 149 x 149 squares (Version 33)
    TECIT_HS("(34) 153 x 153")                      eQRVers_34,     ///< =34: Fixed symbol-size 153 x 153 squares (Version 34)
    TECIT_HS("(35) 157 x 157")                      eQRVers_35,     ///< =35: Fixed symbol-size 157 x 157 squares (Version 35)
    TECIT_HS("(36) 161 x 161")                      eQRVers_36,     ///< =36: Fixed symbol-size 161 x 161 squares (Version 36)
    TECIT_HS("(37) 165 x 165")                      eQRVers_37,     ///< =37: Fixed symbol-size 165 x 165 squares (Version 37)
    TECIT_HS("(38) 169 x 169")                      eQRVers_38,     ///< =38: Fixed symbol-size 169 x 169 squares (Version 38)
    TECIT_HS("(39) 173 x 173")                      eQRVers_39,     ///< =39: Fixed symbol-size 173 x 173 squares (Version 39)
    TECIT_HS("(40) 177 x 177")                      eQRVers_40,     ///< =40: Fixed symbol-size 177 x 177 squares (Version 40)
} e_QRVersion;

 
//----------------------------------------------------------------------------
///  Available encoding formats for QR-Code.
//----------------------------------------------------------------------------
typedef enum /*tagE_QRFormat*/
{
    TECIT_HS("Default")                             eQRPr_Default,  ///< =0: The standard format of QR-Code without a special header
    TECIT_HS("UCC/EAN")                             eQRPr_UCCEAN,   ///< =1: Mode UCC/EAN: Special format defined by UCC and EAN. Used for encoding of so-called Application Identifiers (FNC1 is added at first position)
    TECIT_HS("Industry")                            eQRPr_Industry  ///< =2: Mode Industry: For special industry formats (FNC1 is inserted at second position). If you choose this value, you also have to fill out the field Application Indicator (2 digits or 1 letter). It determines to which industry format the input data (should) correspond(s)
}  e_QRFormat;


//----------------------------------------------------------------------------
//
//  QR Code Error Correction Levels
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
///  Available error correction levels (ECC) for QR-Code.
//----------------------------------------------------------------------------
typedef enum /*tagE_QRECLevel*/
{
    TECIT_HS("(L)ow")                               eQREC_Low,      ///< =0: Lowest level. Data recovery capacity is approximately up to 7%.
    TECIT_HS("(M)edium")                            eQREC_Medium,   ///< =1: Default EC-Level. Up to 15%
    TECIT_HS("(Q)uartil")                           eQREC_Quartil,  ///< =2: Up to 25%
    TECIT_HS("(H)igh")                              eQREC_High,     ///< =3: Highest level. Up to 30%
}  e_QRECLevel;


//----------------------------------------------------------------------------
///  Available mask patterns for QR-Code.
//----------------------------------------------------------------------------
typedef enum /*tagE_QRMask*/
{
    TECIT_HS("Default")                             eQRMsk_Default = -1,    ///< =-1: Default: Mask is computed automatically (time consuming!)
    TECIT_HS("Mask 0")                              eQRMsk_0,               ///< =0: Use fixed mask 0 
    TECIT_HS("Mask 1")                              eQRMsk_1,               ///< =1: Use fixed mask 1 
    TECIT_HS("Mask 2")                              eQRMsk_2,               ///< =2: Use fixed mask 2 
    TECIT_HS("Mask 3")                              eQRMsk_3,               ///< =3: Use fixed mask 3 
    TECIT_HS("Mask 4")                              eQRMsk_4,               ///< =4: Use fixed mask 4 
    TECIT_HS("Mask 5")                              eQRMsk_5,               ///< =5: Use fixed mask 5 
    TECIT_HS("Mask 6")                              eQRMsk_6,               ///< =6: Use fixed mask 6 
    TECIT_HS("Mask 7")                              eQRMsk_7,               ///< =7: Use fixed mask 7 
}  e_QRMask;

//----------------------------------------------------------------------------
///  Available Multi Byte character compression (Kanji, Chinese) for QR-Code.
//----------------------------------------------------------------------------
typedef enum /*tagE_QRMBCompaction*/
{
    TECIT_HS("No MB compaction (Default)")          eQRMBCompactionNone,     ///< =0: Default: No Multi Byte character compression
    TECIT_HS("Kanji character compaction")          eQRMBCompactionKanji,    ///< =1: Use Kanji compaction (Multi Byte charset Shift JIS X 0208)
    TECIT_HS("Chinese character compaction")        eQRMBCompactionChinese,  ///< =2: Use Chinese compation (Multi Byte charset GB2312)
}  e_QRMBCompaction;

//----------------------------------------------------------------------------
///  Available encoding formats for Codablock-F.
//----------------------------------------------------------------------------
typedef enum /*tagE_CBFFormat*/
{
    TECIT_HS("Default")                             eCBFPr_Default,         ///< =0: Standard format
    TECIT_HS("UCC/EAN")                             eCBFPr_UCCEAN,          ///< =1: Special format defined by UCC and EAN to be used in UCC/EAN applications. Used for encoding of so-called Application Identifiers - a FNC1 is encoded at first position automatically.
}  e_CBFFormat;                                                             


//----------------------------------------------------------------------------
///  Available symbol sizes for MicroPDF.
//----------------------------------------------------------------------------
typedef enum /*tagE_MPDFVersions*/
{
    TECIT_HS("Default (auto select)")               eMPDFVer_Default,       ///< =0: Compute size of MicroPDF symbol automatically
    TECIT_HS("1 x 11")                              eMPDFVer_1x11,          ///< =1: Fixed symbol-size columns x rows (1 x 11) 
    TECIT_HS("1 x 14")                              eMPDFVer_1x14,          ///< =2: Fixed symbol-size columns x rows (1 x 14)
    TECIT_HS("1 x 17")                              eMPDFVer_1x17,          ///< =3: Fixed symbol-size columns x rows (1 x 17)
    TECIT_HS("1 x 20")                              eMPDFVer_1x20,          ///< =4: Fixed symbol-size columns x rows (1 x 20)
    TECIT_HS("1 x 24")                              eMPDFVer_1x24,          ///< =5: Fixed symbol-size columns x rows (1 x 24)
    TECIT_HS("1 x 28")                              eMPDFVer_1x28,          ///< =6: Fixed symbol-size columns x rows (1 x 28)
            
    TECIT_HS("2 x 8")                               eMPDFVer_2x8,           ///< =7: Fixed symbol-size columns x rows (2 x 8)
    TECIT_HS("2 x 11")                              eMPDFVer_2x11,          ///< =8: Fixed symbol-size columns x rows (2 x 11)
    TECIT_HS("2 x 14")                              eMPDFVer_2x14,          ///< =9: Fixed symbol-size columns x rows (2 x 14)
    TECIT_HS("2 x 17")                              eMPDFVer_2x17,          ///< =10: Fixed symbol-size columns x rows (2 x 17)
    TECIT_HS("2 x 20")                              eMPDFVer_2x20,          ///< =11: Fixed symbol-size columns x rows (2 x 20)
    TECIT_HS("2 x 23")                              eMPDFVer_2x23,          ///< =12: Fixed symbol-size columns x rows (2 x 23)
    TECIT_HS("2 x 26")                              eMPDFVer_2x26,          ///< =13: Fixed symbol-size columns x rows (2 x 26)

    TECIT_HS("3 x 6")                               eMPDFVer_3x6,           ///< =14: Fixed symbol-size columns x rows (3 x 6)
    TECIT_HS("3 x 8")                               eMPDFVer_3x8,           ///< =15: Fixed symbol-size columns x rows (3 x 8)
    TECIT_HS("3 x 10")                              eMPDFVer_3x10,          ///< =16: Fixed symbol-size columns x rows (3 x 10)
    TECIT_HS("3 x 12")                              eMPDFVer_3x12,          ///< =17: Fixed symbol-size columns x rows (3 x 12)
    TECIT_HS("3 x 15")                              eMPDFVer_3x15,          ///< =18: Fixed symbol-size columns x rows (3 x 15)
    TECIT_HS("3 x 20")                              eMPDFVer_3x20,          ///< =19: Fixed symbol-size columns x rows (3 x 20)
    TECIT_HS("3 x 26")                              eMPDFVer_3x26,          ///< =20: Fixed symbol-size columns x rows (3 x 26)
    TECIT_HS("3 x 32")                              eMPDFVer_3x32,          ///< =21: Fixed symbol-size columns x rows (3 x 32)
    TECIT_HS("3 x 38")                              eMPDFVer_3x38,          ///< =22: Fixed symbol-size columns x rows (3 x 38)
    TECIT_HS("3 x 44")                              eMPDFVer_3x44,          ///< =23: Fixed symbol-size columns x rows (3 x 44)
            
    TECIT_HS("4 x 4")                               eMPDFVer_4x4,           ///< =24: Fixed symbol-size columns x rows (4 x 4)
    TECIT_HS("4 x 6")                               eMPDFVer_4x6,           ///< =25: Fixed symbol-size columns x rows (4 x 6)
    TECIT_HS("4 x 8")                               eMPDFVer_4x8,           ///< =26: Fixed symbol-size columns x rows (4 x 8)
    TECIT_HS("4 x 10")                              eMPDFVer_4x10,          ///< =27: Fixed symbol-size columns x rows (4 x 10)
    TECIT_HS("4 x 12")                              eMPDFVer_4x12,          ///< =28: Fixed symbol-size columns x rows (4 x 12)
    TECIT_HS("4 x 15")                              eMPDFVer_4x15,          ///< =29: Fixed symbol-size columns x rows (4 x 15)
    TECIT_HS("4 x 20")                              eMPDFVer_4x20,          ///< =30: Fixed symbol-size columns x rows (4 x 20)
    TECIT_HS("4 x 26")                              eMPDFVer_4x26,          ///< =31: Fixed symbol-size columns x rows (4 x 26)
    TECIT_HS("4 x 32")                              eMPDFVer_4x32,          ///< =32: Fixed symbol-size columns x rows (4 x 32)
    TECIT_HS("4 x 38")                              eMPDFVer_4x38,          ///< =33: Fixed symbol-size columns x rows (4 x 38)
    TECIT_HS("4 x 44")                              eMPDFVer_4x44,          ///< =34: Fixed symbol-size columns x rows (4 x 44)
} e_MPDFVers;


//----------------------------------------------------------------------------
///  Available encoding formats for Micro-PDF.
//----------------------------------------------------------------------------
typedef enum /*tagE_MPDFModes*/
{
    TECIT_HS("Normal (Default)")                      eMPDFPr_Default,      ///< =0: Default encoding mode (choose best internal representation). Input data is analyzed and text, numeric or binary compaction mode will be used accordingly (to produce the smallest symbol).
    TECIT_HS("Binary Compaction")                     eMPDFPr_Binary,       ///< =1: Binary Compaction (faster if binary data is to be encoded. Encoding will be in binary mode without data analysis
    TECIT_HS("UCC/EAN-128 Emulation")                 eMPDFPr_EAN128,       ///< =2: UCC/EAN-128 Emulation. Transmit ]C1 or ]L3, Use compaction for AI "01" + 14 digits
    TECIT_HS("Code 128 Emulation")                    eMPDFPr_C128Std,      ///< =3: Code128 Emulation. Transmit ]C2 or ]L4
    TECIT_HS("Code 128/FNC2 Emul.")                   eMPDFPr_C128FNC2,     ///< =4: Code128 FNC2 Emulation. Code-128 with FNC2 on first position will be emulated
    TECIT_HS("Linked UCC/EAN-128")                    eMPDFPr_EAN128Lk,     ///< =5: Linked UCC/EAN-128 emulation. 
                                                                            ///< Transmit ]C1 or ]L3.
                                                                            ///< Indicates that the MicroPDF symbol is linked with a linear symbol (which may be required for a successful scan).
                                                                            ///< Using this mode, the following AI's in the given order can be encoded with better compaction:
                                                                            ///<
                                                                            ///< - date (AI 11, 13, 15 or 17) + lot number (AI 10) + other AI's (optional)
                                                                            ///< - date (AI 11, 13, 15 or 17) + serial number (AI 21) + other AI's (optional).
                                                                            ///< - date (AI 11, 13, 15 or 17) + other AI's (optional)
                                                                            ///< Note: This mode is not used with UCC.EAN Composite Symbology, which uses linked symbols, too
    TECIT_HS("05 Macro")                              eMPDFPr_05Macro,      ///< =6: 05 Macro. The preamble [ ( > RS 0 5 GS preceeds the encoded data.
    TECIT_HS("06 Macro")                              eMPDFPr_06Macro,      ///< =7: 06 Macro. The preamble [ ( > RS 0 6 GS preceeds the encoded data.
    TECIT_HS("CC-A Data Mode")                        eMPDFPr_CCA,          ///< =8: CC-A Data Mode. For special applications only: use Base-928 compaction, process input data as Byte array
    TECIT_HS("CC-B Prefix")                           eMPDFPr_CCB,          ///< =9: CC-B Data Mode. For special applications only: use binary compaction (Base-900), prefix symbol data with reserved symbology code word 
}  e_MPDFMode;


//----------------------------------------------------------------------------
//
//  EAN.UCC Composite Symbology CC Type
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
///  Available Composite Component (CC) Types for EAN.UCC Composite Symbologies.
///  The composite component can be chosen automatically by TBarCode or adjusted by the user.
//----------------------------------------------------------------------------
typedef enum /*tagE_2DCompositeComponent*/
{
  TECIT_HS("None")                                eCC_None,           ///< =0: Composite Symbologies are disabled.
  TECIT_HS("Auto Select")                         eCC_Auto,           ///< =1:Automatically choose CC-A, CC-B or CC-C Type depending on the length of the input data.
  TECIT_HS("CC-A")                                eCC_A,              ///< =2: Use composite component A (CC-A).
                                                                      ///< CC-A is a variant of the MicroPDF417 Symbol with a unique combination of row address patterns (RAP). It is the smallest variant of the 2-dimensional composite component. Up to 56 characters can be coded (also alphanumeric) with 3 to 12 rows and 4 columns.
  TECIT_HS("CC-B")                                eCC_B,              ///< =3: Use composite component B (CC-B).
                                                                      ///< CC-B is a subset of the MicroPDF417 Symbol, which is identified by the code word 920. CC-B will be chosen automatically when CC-A has not enough capacity (in Auto-mode). CC-B encodes up to 338 Characters (alphanumeric) in 3 to 12 rows and 2 to 4 columns.
  TECIT_HS("CC-C")                                eCC_C,              ///< =4: Use composite component C (CC-C).
                                                                      ///< The CC-C structure is a PDF417 Symbol, which is identified by the internal code word 920 (920 is the first code word after the symbol length indicator). The CC-C structure can be used as a 2 dimensional composite component of a UCC/EAN-128 Composite Symbols. It has the largest data capacity of EAN.UCC Composite Symbols because of its possibility to code of up to 2361 numbers. It can code numbers and alphanumeric characters with up to 2361 characters, which have 3 to 30 rows and up to 30 Data-Error-checking-Code-Columns.
}  e_CCType;


//----------------------------------------------------------------------------
///  Available options for trimming input data.
//----------------------------------------------------------------------------
typedef enum /*tagE_TrimSpaces*/
{
  TECIT_HS("None")                                eTrim_None,         ///< =0: Do not trim input data
  TECIT_HS("Left")                                eTrim_Left,         ///< =1: Trim all spaces from left side of input data 
  TECIT_HS("Right")                               eTrim_Right,        ///< =2: Trim all spaces from right side of input data 
  TECIT_HS("All")                                 eTrim_All,          ///< =3: Trim all spaces from both sides of input data 
}
e_TrimSpaces;


//----------------------------------------------------------------------------
//
// enum BarSimm defaults
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//  Available options for BarSimm compatibility.
/// Not implemented now. Reserved for future versions.
//----------------------------------------------------------------------------
typedef enum /*tagE_DefaultSet*/
{
    TECIT_HS("None")                                eBSDefault_None,
    TECIT_HS("Set1")                                eBSDefault_Set1,
    TECIT_HS("Set2")                                eBSDefault_Set2,
}
e_DefaultSet;


//----------------------------------------------------------------------------
///  Error codes returned by TBarCode.
//----------------------------------------------------------------------------
typedef enum /*tagE_ErrorCode*/
{
    eErr_OK                       = 0x00000000L,                    ///<    No Error
    eErr_Invalid_Parameter        = 0x80070057L,                    ///<    Invalid parameter/unsupported value
    eErr_Invalid_Data             = 0x8007000DL,                    ///<    Wrong character,
    eErr_Bad_Len                  = 0x80090004L,                    ///<    Wrong number of input characters,
    eErr_Bad_Len_CC               = 0x80090005L,                    ///<    Invalid number of input characters in combination with Composite Component,
    eErr_Insufficient_Buffer      = 0x8007007AL,                    ///<    Input string too long,
    eErr_Draw                     = 0x80040140L,                    ///<    Barcode does not fit into bounding rectangle,
    eErr_Empty                    = 0x800710D2L,                    ///<    No input characters,
    eErr_Not_Supported            = 0x80070032L,                    ///<    Not supported,
    eErr_Not_Implemented          = 0x80004001L,                    ///<    Not implemented (reserved for future use)
}
e_ErrorCode;


/// Defines the supported color modes.
typedef enum
{
  enColorModeRgb,         ///< RGB color mode
  enColorModeGrayscale,   ///< Grayscale color mode
  enColorModeCmyk         ///< CMYK color mode
}
e_ColorMode;


/// Defines the supported color modes.
typedef enum
{
  enPCL5,             ///< PCL5 with HPGL/2
  enPCL5NoHPGL,       ///< PCL5 without HPGL/2
}
e_PCLMode;


//----------------------------------------------------------------------------
///  Type of barcode decoder (necessary for auto-computation of minimal module width).
//----------------------------------------------------------------------------
typedef enum 
{
  /// Barcode decoder is unkown or barcode may be scanned with hardware and software decoders.
	TECIT_HS("Barcode decoder is unkown or barcode may be scanned with hardware and software decoders.")  eDecoder_All = 0,
  /// Output is optimized for hardware barcode scanner.
  TECIT_HS("Hardware barcode scanner")	eDecoder_Hardware,
  /// Output is optimized for Software barcode scanner.
	TECIT_HS("Software barcode decoder")	eDecoder_Software,
  /// Output is optimized for TEC-IT's barcode scanning solution TBarCode InForm. 
  TECIT_HS("TBarCode InForm")	eDecoder_TBarCodeInForm,
} e_Decoder;


//----------------------------------------------------------------------------
///  Type of barcode scanner for which the output should be optimized.
//----------------------------------------------------------------------------
typedef enum /*tag_StructuredAppendMode*/
{	
  /// No structured append information is used. The barcode data of multiple barcodes could be
  /// corrupted if the barcodes are scanned in the wrong order.\n
	TECIT_HS("No structured append information")	eSAM_None = 0,
  /// The standard structured append mode of the barcodes is used. This mode allows a barcode 
  /// scanner to append the data of multiple barcodes correctly, even if they are scanned 
  /// in the wrong order. \n
  /// Note: Not all barcodes have a native structured append mode defined in the barcode standard.\n
	TECIT_HS("Use standard structured append method of current symbology")	eSAM_Standard,
  /// A custom structured append mode is used. The data of each barcode begins with 4 special bytes: 
  ///  - Index (1 Byte, beginning with 1 for the first barcode - not a zero-based index) +
  ///  - Total number of barcodes (1 Byte) +
  ///  - Random File ID (2 Bytes) to identify the barcode series.
  /// This information is supported by TEC-IT's barcode scanning solution TBarCode InForm and can be used
  /// in custom barcode scanner applications.
  TECIT_HS("Use custom structured append info (symbology-independent)")	eSAM_TBarCode,
} e_StructuredAppendMode;


//----------------------------------------------------------------------------
/// Type of compression used for content of barcode.
/// \note Compression should only be used with barcodes which support binary data
//----------------------------------------------------------------------------
typedef enum /*tag_Compression*/
{	
  /// Barcode data is not compressed.
	TECIT_HS("No Compression")	eCompression_None = 0,
  /// Barcode data is compressed with the Deflate algorithm (RFC 1951).
	TECIT_HS("Deflate (RFC 1951)")	eCompression_Deflate,
  /// Barcode data is compressed with the GZip algorithm (RFC 1952).
  TECIT_HS("GZip (RFC 1952)")	eCompression_GZip,
  /// Barcode data is compressed with the ZLib algorithm (RFC 1950).
  TECIT_HS("ZLib (RFC 1950)")	eCompression_ZLib,
}
e_Compression;


//----------------------------------------------------------------------------
/// GDI drawing method.
/// Normal GDI drawing methods (like GDI rectangle drawing functions) can lead 
/// to sub-optimal output quality. Therefore, TBarCode can use special drawing
/// methods for more accurate barcodes.
//----------------------------------------------------------------------------
typedef enum /*tag_DrawMode*/
{	
  /// The default GDI drawing method is used.\n
	TECIT_HS("Default")	eDrawMode_Default = 0,
  /// The GDI rectangle functions are used. This method results in the best performance.\n
	TECIT_HS("Use GDI rectangle funtions (best performance)") eDrawMode_Rectangle,
  /// Special GDI functions are used. This method results in the best quality but 
  /// may not be supported by some applications or printers.\n
  TECIT_HS("Use special GDI functions (best quality)")	eDrawMode_Special,
  /// A combination of GDI drawing methods is used. This method produces correct
  /// output in all applications and printers but might decrease drawing speed.\n
  TECIT_HS("Use a combination of these methods (fail-safe variant)") eDrawMode_Combo,
} e_DrawMode;


//----------------------------------------------------------------------------
/// Type of bounding rectangle.
/// By default the bounding rectangle is static (constant extents).\n
/// Bounding rectangles can be changed to dynamic bounding rectangles which
/// can grow horizontally or vertically.
//----------------------------------------------------------------------------
typedef enum /*tag_DynamicBoundingRect*/
{	
  /// The bounding rectangle cannot grow.
	TECIT_HS("Static (fixed) Bounding Rectangle")	eDynamicBoundingRect_None = 0,	
  /// The bounding rectangle can grow horizontally.
  TECIT_HS("Bounding rectangle grows horizontally")	eDynamicBoundingRect_Horizontal,
  /// The bounding rectangle can grow vertically.
  TECIT_HS("Bounding rectangle grows vertically") eDynamicBoundingRect_Vertical,
} e_DynamicBoundingRect;


//---------------------------------------------------------------------------
/// Determines how the size of the barcode and the single modules are set.
//---------------------------------------------------------------------------
typedef enum 
{
  /// Default size mode.
  /// The size mode is chosen automatically depending on the other barcode settings:
  /// If module width is set (DLL: function BCSetModWidth(); OCX: property TBarCode7Lib::ITBarCodeBase::ModuleWidth), then #eSizeMode_CustomModuleWidth is used; otherwise #eSizeMode_FitToBoundingRect.\n
  TECIT_HS("Use default mode.")	eSizeMode_Default = -1,
  /// The biggest barcode that fits into the bounding rectangle is chosen.\n
  TECIT_HS("Let the barcode fit to the bounding rectangle.") eSizeMode_FitToBoundingRect,
  /// The barcode size is determined by the module width, which is set by
  /// BCSetModWidth() and BCSetModWidthN() (DLL) or TBarCode7Lib::ITBarCodeBase::ModuleWidth (OCX).\n
  TECIT_HS("Use custom module width.")	eSizeMode_CustomModuleWidth,
  /// The barcode size is determined by the module width. A minimal module width is automatically calculated for
  /// a given resolution and optimzed for the barcode decoder. 
  /// The output/scanning resolution has to be set with BCSetDPI(). The type of barcode decoder has to be 
  /// set with BCSetDecoder().\n
  TECIT_HS("Auto-calculate minimal module width.")	eSizeMode_MinimalModuleWidth,
} e_SizeMode;


#endif // !__TECBCEnum_H
#endif // !__TBarCode_h__ (See remark above.)
